// -------------------------------------------------------------------------------
// 
// 		cwCu		}XNwb_t@C
// 
// 				Ver 3.15a
// 
// -------------------------------------------------------------------------------

#ifndef __DXMASK_H__
#define __DXMASK_H__

#include "DxCompileConfig.h"

#ifndef DX_NON_MASK

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxMemImg.h"
#include "DxHandle.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// }XNf[^p\
struct MASKDATA
{
	HANDLEINFO				HandleInfo ;							// nhʏ

	BYTE					*SrcData ;								// }XN\[Xf[^
	int						SrcDataPitch ;							// \[Xf[^sb`
	int						MaskWidth, MaskHeight ;					// }XN̕ƍ
	int						ValidFlag ;								// LtO
	int						TransMode ;								// ߐF[h
} ;

// }XNf[^Ǘp\
struct MASKMANAGEDATA
{
	int						InitializeFlag ;						// tO

	int						MaskBufferSizeX, MaskBufferSizeY ;		// }XNf[^obt@̃TCY
	BYTE					*MaskBuffer ;							// }XNf[^obt@
	int						MaskBufferPitch ;						// }XNf[^obt@̃sb`

	int						MaskScreenGraphHandle ;					// }XNʂƂĎgpOtBbNnhA ̏ꍇ 0 ( At@`l}XNƂĎgp )

	int						MaskReverseEffectFlag ;					// }XN̐lɑ΂ʂt]
	int						FullScreenMaskUpdateFlag ;				// Sʃ}XNXVsĂ邩̃tO
	int						CreateMaskFlag ;						// }XNT[tFX쐬Ă邩ÃtO
	int						MaskUseFlag ;							// }XNgp邩AtO
	int						MaskValidFlag ;							// MaskUseFlag  CreateMaskFlag  & 

	int						MaskBeginFunctionCount ;				// }XNgp`̑OɌĂԊ֐Ă΂ꂽ

	int						ValidMaskDrawMemImg ;					// MaskDrawMemImg LǂÃtO
	MEMIMG					MaskDrawMemImg ;						// }XNgp̕`T[tFX̑ MEMIMG
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// }XN֌W̏
extern MASKMANAGEDATA MaskManageData ;


// ֐vg^Cv錾-----------------------------------------------------------

extern	int			Mask_Initialize( void ) ;																				// }XN̏
extern	int			Mask_Terminate( void ) ;																				// }XŇn

extern	int			Mask_ReleaseSurface( void ) ;																			// }XNXN[ꎞ폜
extern	int			Mask_ReCreateSurface( void ) ;																			// }XNXN[𕜋
extern	int			Mask_CreateScreenFunction( int MaskSurfaceFlag, int Width, int Height ) ;								// }XNXN[쐬֐
extern	int			Mask_CreateSurface( BYTE **MaskBuffer, int *BufferPitch, int Width, int Height, int *TransModeP ) ;		// }XNT[tFX̍쐬

extern	int			Mask_DrawBeginFunction( RECT Rect ) ;																	// }XNgp`̑OɌĂԊ֐
extern	int			Mask_DrawAfterFunction( RECT Rect ) ;																	// }XNgp`̌ɌĂԊ֐

extern	int			Mask_InitializeHandle( HANDLEINFO *HandleInfo ) ;														// }XNnh̏
extern	int			Mask_TerminateHandle( HANDLEINFO *HandleInfo ) ;															// }XNnȟn

extern	int			Mask_MakeMask_UseGParam( int Width, int Height, int ASyncLoadFlag = FALSE ) ;								// }XNf[^̒ǉ
extern	int			Mask_LoadMask_UseGParam(             const wchar_t *FileName,                                                                                        int ASyncLoadFlag = FALSE ) ;	// }XNf[^摜t@Cǂݍ
extern	int			Mask_LoadDivMask_UseGParam(          const wchar_t *FileName,                  int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleBuf, int ASyncLoadFlag = FALSE ) ;	// }XN摜t@C番ǂ݂
extern	int			Mask_CreateMaskFromMem_UseGParam(    const void *FileImage, int FileImageSize,                                                                       int ASyncLoadFlag = FALSE ) ;	// }XNf[^̉摜t@CC[Wǂݍ
extern	int			Mask_CreateDivMaskFromMem_UseGParam( const void *FileImage, int FileImageSize, int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleBuf, int ASyncLoadFlag = FALSE ) ;	// }XN̉摜t@CC[W番ǂ݂



// ˑ֐
extern	int			Mask_CreateScreenFunction_Timing0_PF( void ) ;															// }XNXN[쐬֐
extern	int			Mask_CreateScreenFunction_Timing1_PF( int Width, int Height ) ;											// }XNXN[쐬֐
extern	int			Mask_CreateScreenFunction_Timing2_PF( int MaskBufferSizeXOld, int MaskBufferSizeYOld ) ;				// }XNXN[쐬֐
extern	int			Mask_ReleaseSurface_PF( void ) ;																		// }XNXN[ꎞ폜
extern	int			Mask_SetUseMaskScreenFlag_PF( void ) ;																	// }XNgp[hύX
extern	int			Mask_DrawBeginFunction_PF( RECT *Rect ) ;																// }XNgp`̑OɌĂԊ֐( łɃTuobt@gp`GA@\gpĂꍇ̏Ă܂Ă )
extern	int			Mask_DrawAfterFunction_PF( RECT *Rect ) ;																// }XNgp`̌ɌĂԊ֐( łɃTuobt@gp`GA@\gpĂꍇ̏Ă܂Ă )
extern	int			Mask_FillMaskScreen_PF( int Flag ) ;																	// }XNXN[w̐FœhԂ
extern	int			Mask_UpdateMaskImageTexture_PF( RECT *Rect ) ;															// ẅ̃}XNC[WeNX`XV




// wchar_tŊ֐
extern	int			LoadMask_WCHAR_T(						const wchar_t *FileName ) ;
extern	int			LoadDivMask_WCHAR_T(					const wchar_t *FileName, int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleBuf ) ;
#ifndef DX_NON_FONT
extern	int			DrawFormatStringMask_WCHAR_T(			int x, int y, int Flag,                 const wchar_t *FormatString, ... ) ;
extern	int			DrawFormatStringMaskToHandle_WCHAR_T(	int x, int y, int Flag, int FontHandle, const wchar_t *FormatString, ... ) ;
extern	int			DrawStringMask_WCHAR_T(					int x, int y, int Flag,                 const wchar_t *String ) ;
extern	int			DrawStringMaskToHandle_WCHAR_T(			int x, int y, int Flag, int FontHandle, const wchar_t *String ) ;
#endif // DX_NON_FONT



#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif //	DX_NON_MASK

#endif // __DXMASK_H__
