// -------------------------------------------------------------------------------
// 
// 		cwCu		`揈vO( Direct3D9 )wb_t@C
// 
// 				Ver 3.15a
// 
// -------------------------------------------------------------------------------

#ifndef __DXGRAPHICSD3D9_H__
#define __DXGRAPHICSD3D9_H__

#include "../DxCompileConfig.h"

#ifndef DX_NON_DIRECT3D9

// CN[h ------------------------------------------------------------------
#include "../DxLib.h"
#include "../DxGraphics.h"
#include "../DxArchive_.h"
#include "DxGraphicsAPIWin.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

#define GD3D9								GraphicsHardDataDirect3D9

// foCX񋓂̍ő吔
#define DX_D3D9_MAX_DEVICE_LISTUP			(32)

// Graphics_D3D9_DrawPreparation ֐ɓntO
#define DX_D3D9_DRAWPREP_TRANS				(0x00001)
#define DX_D3D9_DRAWPREP_VECTORINT			(0x00002)
#define DX_D3D9_DRAWPREP_GOURAUDSHADE		(0x00008)
#define DX_D3D9_DRAWPREP_PERSPECTIVE		(0x00010)
#define DX_D3D9_DRAWPREP_DIFFUSERGB			(0x00020)
#define DX_D3D9_DRAWPREP_DIFFUSEALPHA		(0x00040)
#define DX_D3D9_DRAWPREP_FOG				(0x00080)
#define DX_D3D9_DRAWPREP_NOBLENDSETTING		(0x00100)
#define DX_D3D9_DRAWPREP_LIGHTING			(0x00200)
#define DX_D3D9_DRAWPREP_SPECULAR			(0x00400)
#define DX_D3D9_DRAWPREP_3D					(0x00800)
#define DX_D3D9_DRAWPREP_TEXADDRESS			(0x01000)
#define DX_D3D9_DRAWPREP_NOTSHADERRESET		(0x02000)
#define DX_D3D9_DRAWPREP_CULLING			(0x04000)
#define DX_D3D9_DRAWPREP_TEXTURE			(0x08000)
#define DX_D3D9_DRAWPREP_TEXALPHACH			(0x10000)
#define DX_D3D9_DRAWPREP_TEXALPHATEST		(0x20000)
//#define DX_D3D9_DRAWPREP_EDGEFONT			(0x40000)

// VF[_[萔Zbg}XN
#define DX_SHADERCONSTANTSET_MASK_LIB		0x0001
#define DX_SHADERCONSTANTSET_MASK_LIB_SUB	0x0002
#define DX_SHADERCONSTANTSET_MASK_MV1		0x0004
#define DX_SHADERCONSTANTSET_MASK_USER		0x0008

// sNZPʃCeBO^Cv̒_VF[_[ʃR[h쐬p}N
#define D3D9_PIXELLIGHTING_VERTEXSHADER_SHADOWMAP( use )		( ( use )  * 3 * 2 * 4 )
#define D3D9_PIXELLIGHTING_VERTEXSHADER_SKINMESH( use )			( ( use )  * 2 * 4 )
#define D3D9_PIXELLIGHTING_VERTEXSHADER_BUMPMAP( use )			( ( use )  * 4 )
#define D3D9_PIXELLIGHTING_VERTEXSHADER_FOGMODE( mode )			( ( mode ) )

// sNZPʃCeBO^Cv̒_VF[_[ʃR[hevf擾邽߂̃}N
#define D3D9_PIXELLIGHTING_VERTEXSHADER_GET_SHADOWMAP( index )	( ( index ) / ( 3 * 2 * 4 ) % 2 )
#define D3D9_PIXELLIGHTING_VERTEXSHADER_GET_SKINMESH( index )	( ( index ) / ( 2 * 4 ) % 3 )
#define D3D9_PIXELLIGHTING_VERTEXSHADER_GET_BUMPMAP( index )	( ( index ) / ( 4 ) % 2 )
#define D3D9_PIXELLIGHTING_VERTEXSHADER_GET_FOGMODE( index )	( ( index ) % 4 )

// sNZPʃCeBO^CṽsNZVF[_[^Cv
#define D3D9_PIXELLIGHTING_PIXELSHADER_TYPE_NORMAL				0	
#define D3D9_PIXELLIGHTING_PIXELSHADER_TYPE_TOON				1

// sNZPʃCeBO^CṽsNZVF[_[ʃR[h쐬p}N
#define D3D9_PIXELLIGHTING_PIXELSHADER_TYPE( type )				( ( type  ) * 2 * 5 * 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_SHADOWMAP( use )			( ( use   ) * 5 * 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_MULTITEX( type )			( ( type  ) * 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_TOONTYPE( type )			( ( type  ) * 3 * 2 * 2 * 2 * 2 * 84 * 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_TOONSPHEREOP( type )		( ( type  ) * 2 * 2 * 2 * 2 * 84 * 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_TOONDIFBLDOP( type )		( ( type  ) * 2 * 2 * 2 * 84 * 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_TOONSPCBLDOP( type )		( ( type  ) * 2 * 2 * 84 * 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_SPECULARMAP( use )		( ( use   ) * 2 * 84 * 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_BUMPMAP( use )			( ( use   ) * 84 * 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_LIGHTINDEX( index )		( ( index ) * 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_SPECULAR( use )			( ( use   ) )

// sNZPʃCeBO^CṽsNZVF[_[ʃR[hevf擾邽߂̃}N
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_TYPE( index )			( ( index ) / ( 2 * 5 * 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 ) % 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_SHADOWMAP( index )		( ( index ) / ( 5 * 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 ) % 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_MULTITEX( index )		( ( index ) / ( 2 * 3 * 2 * 2 * 2 * 2 * 84 * 2 ) % 5 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_TOONTYPE( index )		( ( index ) / ( 3 * 2 * 2 * 2 * 2 * 84 * 2 ) % 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_TOONSPHEREOP( index )	( ( index ) / ( 2 * 2 * 2 * 2 * 84 * 2 ) % 3 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_TOONDIFBLDOP( index )	( ( index ) / ( 2 * 2 * 2 * 84 * 2 ) % 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_TOONSPCBLDOP( index )	( ( index ) / ( 2 * 2 * 84 * 2 ) % 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_SPECULARMAP( index )		( ( index ) / ( 2 * 84 * 2 ) % 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_BUMPMAP( index )			( ( index ) / ( 84 * 2 ) % 2 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_LIGHTINDEX( index )		( ( index ) / ( 2 ) % 84 )
#define D3D9_PIXELLIGHTING_PIXELSHADER_GET_SPECULAR( index )		( ( index ) % 2 )

	// _VF[_[^Cv
#define D3D9_VERTEXSHADER_TYPE_NORMAL					0
#define D3D9_VERTEXSHADER_TYPE_DRAW_SHADOWMAP			1
#define D3D9_VERTEXSHADER_TYPE_TOON_OUTLINE				2

// _VF[_[ʃR[h쐬p}N
#define D3D9_VERTEXSHADER_TYPE( type )					( ( type  ) * 2 * 2 * 3 * 2 * 4 * 20 * 2 )
#define D3D9_VERTEXSHADER_SHADERMODEL( ver )			( ( ver   ) * 2 * 3 * 2 * 4 * 20 * 2 )
#define D3D9_VERTEXSHADER_SHADOWMAP( use )				( ( use   ) * 3 * 2 * 4 * 20 * 2 )
#define D3D9_VERTEXSHADER_MESHTYPE( type )				( ( type  ) * 2 * 4 * 20 * 2 )
#define D3D9_VERTEXSHADER_BUMPMAP( use )				( ( use   ) * 4 * 20 * 2 )
#define D3D9_VERTEXSHADER_FOGMODE( mode )				( ( mode  ) * 20 * 2 )
#define D3D9_VERTEXSHADER_LIGHTINDEX( index )			( ( index ) * 2 )
#define D3D9_VERTEXSHADER_SPECULAR( use )				( ( use   ) )

// _VF[_[ʃR[hevf擾邽߂̃}N
#define D3D9_VERTEXSHADER_GET_TYPE( index )				( ( index ) / ( 2 * 2 * 3 * 2 * 4 * 20 * 2 ) % 3 )
#define D3D9_VERTEXSHADER_GET_SHADERMODEL( index )		( ( index ) / ( 2 * 3 * 2 * 4 * 20 * 2 ) % 2 )
#define D3D9_VERTEXSHADER_GET_SHADOWMAP( index )		( ( index ) / ( 3 * 2 * 4 * 20 * 2 ) % 2 )
#define D3D9_VERTEXSHADER_GET_MESHTYPE( index )			( ( index ) / ( 2 * 4 * 20 * 2 ) % 3 )
#define D3D9_VERTEXSHADER_GET_BUMPMAP( index )			( ( index ) / ( 4 * 20 * 2 ) % 2 )
#define D3D9_VERTEXSHADER_GET_FOGMODE( index )			( ( index ) / ( 20 * 2 ) % 4 )
#define D3D9_VERTEXSHADER_GET_LIGHTINDEX( index )		( ( index ) / ( 2 ) % 20 )
#define D3D9_VERTEXSHADER_GET_SPECULAR( index )			( ( index ) % 2 )

// sNZVF[_[^Cv
#define D3D9_PIXELSHADER_TYPE_NORMAL					0
#define D3D9_PIXELSHADER_TYPE_DRAW_SHADOWMAP			1
#define D3D9_PIXELSHADER_TYPE_TOON_OUTLINE				2

// sNZVF[_[ʃR[h쐬p}N
#define D3D9_PIXELSHADER_TYPE( type )					( ( type  ) * 2 * 2 * 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define D3D9_PIXELSHADER_SHADERMODEL( ver )				( ( ver   ) * 2 * 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define D3D9_PIXELSHADER_SHADOWMAP( use )				( ( use   ) * 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define D3D9_PIXELSHADER_MULTITEX( type )				( ( type  ) * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define D3D9_PIXELSHADER_TOON( use )					( ( use   ) * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define D3D9_PIXELSHADER_TOONTYPE( type )				( ( type  ) * 3 * 2 * 2 * 2 * 2 * 10 * 2 )
#define D3D9_PIXELSHADER_TOONSPHEREOP( type )			( ( type  ) * 2 * 2 * 2 * 2 * 10 * 2 )
#define D3D9_PIXELSHADER_TOONDIFBLDOP( type )			( ( type  ) * 2 * 2 * 2 * 10 * 2 )
#define D3D9_PIXELSHADER_TOONSPCBLDOP( type )			( ( type  ) * 2 * 2 * 10 * 2 )
#define D3D9_PIXELSHADER_SPECULARMAP( use )				( ( use   ) * 2 * 10 * 2 )
#define D3D9_PIXELSHADER_BUMPMAP( use )					( ( use   ) * 10 * 2 )
#define D3D9_PIXELSHADER_LIGHTINDEX( index )			( ( index ) * 2 )
#define D3D9_PIXELSHADER_SPECULAR( use )				( ( use ) )

// sNZVF[_[ʃR[hevf擾邽߂̃}N
#define D3D9_PIXELSHADER_GET_TYPE( index )				( ( index ) / ( 2 * 2 * 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 3 )
#define D3D9_PIXELSHADER_GET_SHADERMODEL( index )		( ( index ) / ( 2 * 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 2 )
#define D3D9_PIXELSHADER_GET_SHADOWMAP( index )			( ( index ) / ( 5 * 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 2 )
#define D3D9_PIXELSHADER_GET_MULTITEX( index )			( ( index ) / ( 2 * 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 5 )
#define D3D9_PIXELSHADER_GET_TOON( index )				( ( index ) / ( 2 * 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 2 )
#define D3D9_PIXELSHADER_GET_TOONTYPE( index )			( ( index ) / ( 3 * 2 * 2 * 2 * 2 * 10 * 2 ) % 2 )
#define D3D9_PIXELSHADER_GET_TOONSPHEREOP( index )		( ( index ) / ( 2 * 2 * 2 * 2 * 10 * 2 ) % 3 )
#define D3D9_PIXELSHADER_GET_TOONDIFBLDOP( index )		( ( index ) / ( 2 * 2 * 2 * 10 * 2 ) % 2 )
#define D3D9_PIXELSHADER_GET_TOONSPCBLDOP( index )		( ( index ) / ( 2 * 2 * 10 * 2 ) % 2 )
#define D3D9_PIXELSHADER_GET_SPECULARMAP( index )		( ( index ) / ( 2 * 10 * 2 ) % 2 )
#define D3D9_PIXELSHADER_GET_BUMPMAP( index )			( ( index ) / ( 10 * 2 ) % 2 )
#define D3D9_PIXELSHADER_GET_LIGHTINDEX( index )		( ( index ) / ( 2 ) % 10 )
#define D3D9_PIXELSHADER_GET_SPECULAR( index )			( ( index ) % 2 )

// _tH[}bg
#define VERTEXFVF_2D_USER					( D_D3DFVF_XYZRHW | D_D3DFVF_DIFFUSE | D_D3DFVF_TEX1 )										// gXtH[ςݒ_tH[}bg
#define VERTEXFVF_NOTEX_2D					( D_D3DFVF_XYZRHW | D_D3DFVF_DIFFUSE )														// CA{bNX`p_tH[}bg
#define VERTEXFVF_2D						( D_D3DFVF_XYZRHW | D_D3DFVF_DIFFUSE | D_D3DFVF_TEX1 )										// gXtH[ςݒ_tH[}bg
#define VERTEXFVF_BLENDTEX_2D				( D_D3DFVF_XYZRHW | D_D3DFVF_DIFFUSE | D_D3DFVF_SPECULAR | D_D3DFVF_TEX2 )					// uheNX`tgXtH[ςݒ_tH[}bg
#define VERTEXFVF_SHADER_2D					( D_D3DFVF_XYZRHW | D_D3DFVF_DIFFUSE | D_D3DFVF_SPECULAR | D_D3DFVF_TEX2 )					// VF[_[`p_tH[}bg
#define VERTEXFVF_NOTEX_3D					( D_D3DFVF_XYZ | D_D3DFVF_DIFFUSE /*| D_D3DFVF_SPECULAR*/ )									// CA{bNX`p_tH[}bgARcp( o[Wp )
#define VERTEXFVF_3D						( D_D3DFVF_XYZ | D_D3DFVF_DIFFUSE /*| D_D3DFVF_SPECULAR*/ | D_D3DFVF_TEX1 )					// OtBbNX`p_tH[}bgARcp( o[Wp )
#define VERTEXFVF_3D_LIGHT					( D_D3DFVF_XYZ | D_D3DFVF_NORMAL | D_D3DFVF_DIFFUSE | D_D3DFVF_SPECULAR | D_D3DFVF_TEX2 )	// OtBbNX`p_tH[}bg
#define VERTEXFVF_SHADER_3D					( D_D3DFVF_XYZ | D_D3DFVF_NORMAL | D_D3DFVF_DIFFUSE | D_D3DFVF_SPECULAR | D_D3DFVF_TEX2 )	// VF[_[`p_tH[}bg

#define VERTEXFVF_DECL_2D_USER				(0)			// gXtH[ςݒ_tH[}bg
#define VERTEXFVF_DECL_NOTEX_2D				(1)			// CA{bNX`p_tH[}bg
#define VERTEXFVF_DECL_2D					(2)			// gXtH[ςݒ_tH[}bg
#define VERTEXFVF_DECL_BLENDTEX_2D			(3)			// uheNX`tgXtH[ςݒ_tH[}bg
#define VERTEXFVF_DECL_SHADER_2D			(4)			// VF[_[`p_tH[}bg
#define VERTEXFVF_DECL_NOTEX_3D				(5)			// CA{bNX`p_tH[}bgARcp( o[Wp )
#define VERTEXFVF_DECL_3D					(6)			// OtBbNX`p_tH[}bgARcp( o[Wp )
#define VERTEXFVF_DECL_3D_LIGHT				(7)			// OtBbNX`p_tH[}bg
#define VERTEXFVF_DECL_SHADER_3D			(8)			// VF[_[`p_tH[}bg
#define VERTEXFVF_DECL_NUM					(9)

// _obt@̃TCY
#define D3DDEV_NOTEX_VERTBUFFERSIZE			(63 * 1024)		// 63KB
#define D3DDEV_TEX_VERTBUFFERSIZE			(64 * 1024)		// 64KB
#define D3DDEV_BLENDTEX_VERTBUFFERSIZE		(64 * 1024)		// 64KB
#define D3DDEV_NOTEX_3D_VERTBUFFERSIZE		(64 * 1024)		// 64KB
#define D3DDEV_TEX_3D_VERTBUFFERSIZE		(64 * 1024)		// 64KB
#define D3DDEV_NOTEX_VERTMAXNUM				(D3DDEV_NOTEX_VERTBUFFERSIZE     / sizeof( VERTEX_NOTEX_2D    ))
#define D3DDEV_TEX_VERTMAXNUM				(D3DDEV_TEX_VERTBUFFERSIZE       / sizeof( VERTEX_2D          ))
#define D3DDEV_BLENDTEX_VERTMAXNUM			(D3DDEV_BLENDTEX_VERTBUFFERSIZE  / sizeof( VERTEX_BLENDTEX_2D ))
#define D3DDEV_NOTEX_3D_VERTMAXNUM			(D3DDEV_NOTEX_3D_VERTBUFFERSIZE  / sizeof( VERTEX_NOTEX_3D    ))
#define D3DDEV_TEX_3D_VERTMAXNUM			(D3DDEV_TEX_3D_VERTBUFFERSIZE    / sizeof( VERTEX_3D          ))

// v~eBu̐Zo
#define GETPRIMNUM( primtype, vertnum )	\
	( DWORD )( \
	( ( (primtype) == D_D3DPT_TRIANGLELIST  ) ? (vertnum) / 3 :\
    ( ( (primtype) == D_D3DPT_LINELIST      ) ? (vertnum) / 2 :\
	( ( (primtype) == D_D3DPT_TRIANGLEFAN   ) ? (vertnum) - 2 :\
	( ( (primtype) == D_D3DPT_TRIANGLESTRIP ) ? (vertnum) - 2 :\
	( ( (primtype) == D_D3DPT_LINESTRIP     ) ? (vertnum) - 1 :\
	( ( (primtype) == D_D3DPT_POINTLIST     ) ? (vertnum)     : 0 ) ) ) ) ) ) )


// ǗeNX`ւ̃f[^]pVXezueNX`̐
#define DIRECT3D9_SYSMEMTEXTURE_NUM					(2048)

// ǗeNX`ւ̃f[^]pVXezuT[tFX̐
#define DIRECT3D9_SYSMEMSURFACE_NUM					(2048)


// \̒` --------------------------------------------------------------------

// Direct3D9p n[hEGA_OpIWi摜eNX`
struct IMAGEDATA_ORIG_HARD_TEX_DIRECT3D9
{
	union
	{
		D_IDirect3DCubeTexture9	*	CubeTexture ;							// L[ueNX`
		D_IDirect3DTexture9		*	Texture ;								// eNX`
	} ;
//	D_IDirect3DTexture9	*			MemTexture ;							// D3DPOOL_MANAGED gpłȂ摜peNX`
	D_IDirect3DSurface9	*			Surface[ CUBEMAP_SURFACE_NUM ] ;		// T[tFX
	D_IDirect3DSurface9	*			RenderTargetSurface ;					// _O^[QbgT[tFX
	D_IDirect3DSurface9	*			ZBuffer ;								// yobt@
} ;

// Direct3D9p VhE}bv
struct SHADOWMAPDATA_DIRECT3D9
{
	D_IDirect3DTexture9		*Texture ;										// eNX`

	D_IDirect3DSurface9		*Surface ;										// T[tFX
	D_IDirect3DSurface9		*ZBufferSurface ;								// yobt@T[tFX
} ;

// Direct3D9p _obt@nh
struct VERTEXBUFFERHANDLEDATA_DIRECT3D9
{
	D_IDirect3DVertexBuffer9	*VertexBuffer ;								// IDirect3DVertexBuffer9 ̃|C^
} ;

// Direct3D9p CfbNXobt@nh
struct INDEXBUFFERHANDLEDATA_DIRECT3D9
{
	D_IDirect3DIndexBuffer9		*IndexBuffer ;								// IDirect3DIndexBuffer9 ̃|C^
} ;

// Direct3D9p VF[_[nh
struct SHADERHANDLEDATA_DIRECT3D9
{
	union
	{
		D_IDirect3DPixelShader9			*PixelShader ;						// IDirect3DPixelShader9 ̃|C^
		D_IDirect3DVertexShader9		*VertexShader ;						// IDirect3DVertexShader9 ̃|C^
	} ;

	int									ConstantNum ;						// 萔̐
	D_D3DXSHADER_CONSTANTINFO			*ConstantInfo ;						// 萔z̐擪AhX
} ;

// Direct3D9p VF[_[p萔obt@nh
struct SHADERCONSTANTBUFFERHANDLEDATA_DIRECT3D9
{
	int			Dummy ;
} ;

// VF[_[萔̈̎gp̈\
struct DIRECT3D9_SHADERCONST_ONE_USEAREA
{
	WORD								Start ;								// gp̈̊Jnԍ
	WORD								EndPlusOne ;						// gp̈̏Iԍ{P
} ;

// VF[_[萔gp̈\
struct DIRECT3D9_SHADERCONSTANT_USEAREA
{
	DIRECT3D9_SHADERCONST_ONE_USEAREA	AreaInfo[ 256 ] ;					// gp̈
	int									AreaInfoNum ;						// gp̈̐
	int									TotalSize ;							// Ǘ̈̃TCY
} ;

// VF[_[萔\
struct DIRECT3D9_SHADERCONSTANTINFO
{
	DIRECT3D9_SHADERCONSTANT_USEAREA	UseArea ;							// [U[p_VF[_[萔̎gp̈
	int									UnitSize ;							// f[^̃TCY

	union
	{
		BYTE							Data[ 256 * 16 ] ;					// TCYۏؗpf[^

		FLOAT4							Float4[ 256 ] ;						// [U[p_VF[_[ float ^萔
		INT4							Int4[ 16 ] ;						// [U[p_VF[_[ int ^萔
		BOOL							Bool[ 16 ] ;						// [U[p_VF[_[ BOOL ^萔
	} ;
} ;

// VF[_[萔Zbg\
struct DIRECT3D9_SHADERCONSTANTINFOSET
{
	int									IsApply[ DX_SHADERCONSTANTSET_NUM ] ;			// 萔Kp邩ǂ( TRUE:Kp  FALSE:KpȂ )
	int									ApplyMask ;										// Kp}XN( DX_SHADERCONSTANTSET_MASK_LIB | DX_SHADERCONSTANTSET_MASK_LIB_SUB  )
	DIRECT3D9_SHADERCONSTANTINFO		Info[ DX_SHADERCONSTANTTYPE_NUM ][ DX_SHADERCONSTANTSET_NUM ] ;				// 萔
	BYTE								UseMap[ DX_SHADERCONSTANTTYPE_NUM ][ DX_SHADERCONSTANTSET_NUM ][ 256 ] ;	// 萔gp}bv

	DIRECT3D9_SHADERCONSTANTINFO		FixInfo[ DX_SHADERCONSTANTTYPE_NUM ] ;			// ۂɃVF[_[ɓKpĂ萔

	BYTE								SetMap[ DX_SHADERCONSTANTTYPE_NUM ][ 256 ] ;	// VF[_[萔̎gpZbg}bv( DX_SHADERCONSTANTSET_LIB A0xff gp )
} ;


// Direct3D9 ̂Qc`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D9_SHADER_2D
{
#ifndef DX_NON_NORMAL_DRAW_SHADER
	// Œ@\pCvC݊p̒_VF[_[
//	D_IDirect3DVertexShader9				*Base2DVertexShader ;
//	D_IDirect3DVertexShader9				*Base3DVertexShader ;

	// Œ@\pCvC݊̃VF[_[( eNX`Ȃ )
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ `llłǂ( 0:lȂ  1:l ) ]
	// [ Zς݃uhpǂ( 0:Zς݃uhpł͂Ȃ  1:Zς݃uhp ) ]
	D_IDirect3DPixelShader9					*BaseNoneTexPixelShader[ 7 ][ 2 ] ;

	// Œ@\pCvC݊̃VF[_[( eNX` )
	// [ uh摜Ƃ̃uh^Cv( 0:Ȃ  1:DX_BLENDGRAPHTYPE_NORMAL  2:DX_BLENDGRAPHTYPE_WIPE  3:DX_BLENDGRAPHTYPE_ALPHA ) ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ eNX`RGB( 0:Ȃ  1: ) ]
	// [ eNX`Alpha( 0:Ȃ  1: ) ]
	// [ `llłǂ( 0:lȂ  1:l ) ]
	D_IDirect3DPixelShader9					*BaseUseTexPixelShader[ 4 ][ 7 ][ 2 ][ 2 ][ 2 ] ;

	// }XNp̃VF[_[
	D_IDirect3DPixelShader9					*MaskEffectPixelShader ;
#endif // DX_NON_NORMAL_DRAW_SHADER
} ;


#ifndef DX_NON_MODEL

// Direct3D9 ̃f`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D9_SHADER_MODEL
{
	// f`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	D_IDirect3DVertexShader9				*MV1_PixelLighting_VertexShader[ 2 ][ 3 ][ 2 ][ 4 ] ;

	// f`psNZPʃCeBO^CṽgD[psNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O Type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	D_IDirect3DPixelShader9					*MV1_PixelLighting_ToonPixelShader[ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 84 ][ 2 ] ;

	// f`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	D_IDirect3DPixelShader9					*MV1_PixelLighting_PixelShader[ 2 ][ 5 ][ 2 ][ 2 ][ 84 ][ 2 ] ;





	// f`p̃gD[_O̗֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	D_IDirect3DVertexShader9				*MV1_ToonOutLineVertexShader[ 3 ][ 4 ] ;

	// f`p̃VhE}bvւ̃_Op_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	D_IDirect3DVertexShader9				*MV1_ShadowMapVertexShader[ 3 ] ;

	// f`p̃CeBOȂ_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	D_IDirect3DVertexShader9				*MV1_NoLightingVertexShader[ 3 ][ 4 ] ;

	// f`p̃CeBO蒸_VF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	D_IDirect3DVertexShader9				*MV1_LightingVertexShader[ 2 ][ 2 ][ 3 ][ 2 ][ 4 ][ 20 ][ 2 ] ;


	// f`p̃gD[_O̗֊s`psNZVF[_[
	D_IDirect3DPixelShader9					*MV1_ToonOutLinePixelShader ;

	// f`p̃VhE}bvւ̃gD[_OpsNZVF[_[
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	D_IDirect3DPixelShader9					*MV1_ShadowMapToonPixelShader[ 2 ][ 3 ][ 2 ] ;

	// f`p̃VhE}bvւ̃_OpsNZVF[_[
	D_IDirect3DPixelShader9					*MV1_ShadowMapPixelShader ;

	// f`p̃CeBOȂgD[psNZVF[_[( Xg͔z̍ )
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	D_IDirect3DPixelShader9					*MV1_ToonNoLightingPixelShader[ 2 ][ 2 ] ;

	// f`p̃CeBOȂsNZVF[_[
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	D_IDirect3DPixelShader9					*MV1_NoLightingPixelShader[ 5 ] ;

	// f`p̃CeBOgD[psNZVF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	D_IDirect3DPixelShader9					*MV1_ToonLightingPixelShader[ 2 ][ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 10 ][ 2 ] ;

	// f`p̃CeBOsNZVF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	D_IDirect3DPixelShader9					*MV1_LightingPixelShader[ 2 ][ 2 ][ 5 ][ 2 ][ 2 ][ 10 ][ 2 ] ;
} ;
#endif // DX_NON_MODEL


// Direct3D9 ̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D9_SHADER
{
//	int											UseShader ;						// vO}uVF[_[gp邩ǂ( TRUE:gp  FALSE:gpȂ )

	DWORD										NativeVertexShaderVersion ;		// G~[V̒_VF[_[̃o[W

	int											ValidVertexShader ;				// _VF[_[gp\ǂ( TRUE:gp\  FALSE:s\ )
	int											ValidPixelShader ;				// sNZVF[_[gp\ǂ( TRUE:gp\  FALSE:s\ )
	int											ValidVertexShader_SM3 ;			// Shader Model 3.0 ̒_VF[_[gp\ǂ( TRUE:gp\  FALSE:s\ )
	int											ValidPixelShader_SM3 ;			// Shader Model 3.0 ̃sNZVF[_[gp\ǂ( TRUE:gp\  FALSE:s\ )

	DIRECT3D9_SHADERCONSTANTINFOSET				ShaderConstantInfo ;			// VF[_[̒萔

	GRAPHICS_HARDWARE_DIRECT3D9_SHADER_2D		_2D ;							// Qc`揈p̃VF[_[Z߂\

#ifndef DX_NON_MODEL
	int											UseBaseVertexShaderIndex ;		// gp钸_VF[_[̃CgEtHOEtHVF[fBO̗L̂ݐݒ肵l
	int											UseBasePixelShaderIndex ;		// gpsNZVF[_[̃CgEtHVF[fBO̗L̂ݐݒ肵l
	int											UseBaseVertexShaderIndex_PL ;	// sNZPʃCeBO^CvŎgp钸_VF[_[̃CgEtHOEtHVF[fBO̗L̂ݐݒ肵l
	int											UseBasePixelShaderIndex_PL ;	// sNZPʃCeBO^CvŎgpsNZVF[_[̃CgEtHVF[fBO̗L̂ݐݒ肵l
	int											UseOnlyPixelLightingTypeCode ;	// sNZPʃCeBO^CṽVF[_[R[hgpwɂȂĂ邩ǂ

	GRAPHICS_HARDWARE_DIRECT3D9_SHADER_MODEL	Model ;							// f`揈p̃VF[_[Z߂\
#endif // DX_NON_MODEL
} ;



// Direct3D9 ̒_VF[_錾Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D9_VERTEXDECLARATION
{
	// ŒpCvC݊VF[_[Ŏgp钸_f[^tH[}bg
	D_IDirect3DVertexDeclaration9 *				Base2DDeclaration[ VERTEXFVF_DECL_NUM ] ;

	// [U[VF[_[hŎgp钸_f[^tH[}bg
	D_IDirect3DVertexDeclaration9 *				UserShaderDeclaration[ DX_VERTEX_TYPE_NUM ] ;

#ifndef DX_NON_MODEL
	// _VF[_錾( Xg͔z̍ )
	// [ ov}bvtǂ( 1:ov}bvt 0:tĂȂ ) ]
	// [ XLjObVǂ( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ UV̐ ]
	D_IDirect3DVertexDeclaration9 *				MV1_VertexDeclaration[ 2 ][ 3 ][ 9 ] ;
#endif // DX_NON_MODEL
} ;



// eNX`Xe[W̏
struct GRAPHICS_HARDDATA_DIRECT3D9_TEXTURESTAGEINFO
{
	void *						Texture ;							// Xe[WɃZbgĂeNX`T[tFX
	int							TextureCoordIndex ;					// gpeNX`WCfbNX
	int							ResultTempARG ;						// o͐惌WX^e|ɂ邩ǂ
	short						AlphaARG1, AlphaARG2, AlphaOP ;		// Direct3DDevice  D3DTSS_ALPHAOP  D3DTSS_ALPHAARG1  D3DTSS_ALPHAARG2 ̐ݒl
	short						ColorARG1, ColorARG2, ColorOP ;		// Direct3DDevice  D3DTSS_COLOROP  D3DTSS_COLORARG1  D3DTSS_COLORARG2 ̐ݒl
} ;

// cRc ̃uhݒɊւݒ̏
struct GRAPHICS_HARDDATA_DIRECT3D9_BLENDINFO
{
	int							AlphaTestEnable ;							// Direct3DDevice9  D3DRS_ALPHATESTENABLE ̐ݒl
	int							AlphaRef ;									// Direct3DDevice9  D3DRS_ALPHAREF ̐ݒl
	int							AlphaFunc ;									// Direct3DDevice9  D3DRS_ALPHAFUNC ̐ݒl
	int							AlphaBlendEnable ;							// Direct3DDevice9  D3DRS_ALPHABLENDENABLE ̐ݒl
	int							SeparateAlphaBlendEnable ;					// Direct3DDevice9  D3DRS_SEPARATEALPHABLENDENABLE ̐ݒl

	DWORD						FactorColor ;								// Direct3DDevice9  D3DRS_TEXTUREFACTOR ̐ݒl
	int							SrcBlend, DestBlend ;						// Direct3DDevice9  D3DRS_DESTBLEND  D3DRS_SRCBLEND ̐ݒl
	int							BlendOp ;									// Direct3DDevice9  D3DRS_BLENDOP ̐ݒl
	int							SrcBlendAlpha, DestBlendAlpha ;				// Direct3DDevice9  D3DRS_DESTBLENDALPHA  D3DRS_SRCBLENDALPHA ̐ݒl
	int							BlendOpAlpha ;								// Direct3DDevice9  D3DRS_BLENDOPALPHA ̐ݒl
	int							UseTextureStageNum ;						// gpĂeNX`Xe[W̐
	GRAPHICS_HARDDATA_DIRECT3D9_TEXTURESTAGEINFO TextureStageInfo[ USE_TEXTURESTAGE_NUM] ;	// Direct3DDevice ̃eNX`Xe[Wݒl( Direct3DDevice ɂꂩK\̐ݒl )
} ;

// Direct3D9Device ɐݒ肵ĂlZ߂\
struct GRAPHICS_HARDDATA_DIRECT3D9_DEVICE_STATE
{
	GRAPHICS_HARDDATA_DIRECT3D9_BLENDINFO	BlendInfo ;										// uh֌W̐ݒ
	int										CullMode ;										// JO[h
	int										DepthBias ;										// [xloCAX
	int										DrawMode ;										// `惂[h
	float									FactorColorPSConstantF[ 4 ] ;					// sNZVF[_[gcwCuWp FactorColor ̒l
	int										FillMode ;										// tB[h
	int										FogEnable ;										// tHOLǂ( TRUE:L  FALSE: )
	int										FogMode ;										// tHO[h
	DWORD									FogColor ;										// tHOJ[
	float									FogStart ;										// tHOJn
	float									FogEnd ;										// tHOI
	float									FogDensity ;									// tHOx
	COLOR_F									GlobalAmbientLightColor ;						// O[oArGgCgJ[
	int										LightEnableMaxIndex ;							// LȃCg̍őCfbNX
	int										LightEnableFlag[ 256 ] ;						// CgLǂtO( TRUE:L  FALSE: )
	D_D3DLIGHT9								LightParam[ 256 ] ;								// Cg̃p[^
	int										Lighting ;										// Cggp邩tO
	D_D3DMATERIAL9							Material ;										// }eA
	int										MaterialUseVertexDiffuseColor ;					// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂ
	int										MaterialUseVertexSpecularColor ;				// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂ
	int										MaxAnisotropy ;									// őٕ
	int										MaxAnisotropyDim[ USE_TEXTURESTAGE_NUM ] ;		// eTv̍őٕ
	D_D3DTEXTUREFILTERTYPE					MagFilter[ USE_TEXTURESTAGE_NUM ] ;				// eTv̊gtB^
	D_D3DTEXTUREFILTERTYPE					MinFilter[ USE_TEXTURESTAGE_NUM ] ;				// eTv̏ktB^
	D_D3DTEXTUREFILTERTYPE					MipFilter[ USE_TEXTURESTAGE_NUM ] ;				// eTṽ~bv}bvtB^
	RECT									ScissorRect ;									// VU[`
	DWORD									SetFVF ;										//  Direct3DDevice9 ɃZbgĂ FVF R[h
	D_IDirect3DIndexBuffer9 *				SetIndexBuffer ;								//  Direct3DDevice9 ɃZbgĂCfbNXobt@
	int										SetNormalVertexShader ;							// ʏ`p_VF[_[ZbgĂ邩ǂ
	int										SetNormalPixelShader ;							// ʏ`psNZVF[_[ZbgĂ邩ǂ
	D_IDirect3DPixelShader9 *				SetPixelShader ;								//  Direct3DDevice9 ɃZbgĂsNZVF[_[
	D_IDirect3DVertexDeclaration9 *			SetVertexDeclaration ;							//  Direct3DDevice9 ɃZbgĂ钸_VF[_錾
	D_IDirect3DVertexShader9 *				SetVertexShader ;								//  Direct3DDevice9 ɃZbgĂ钸_VF[_[
	D_IDirect3DVertexBuffer9 *				SetVertexBuffer ;								//  Direct3DDevice9 ɃZbgĂ钸_obt@
	int										SetVertexBufferStride ;							//  Direct3DDevice9 ɃZbgĂ钸_obt@̃XgCh
	int										ShadeMode ;										// VF[fBO[h
	D_IDirect3DSurface9	*					TargetSurface[DX_RENDERTARGET_COUNT] ;			// `Ώۂ̃T[tFX
	int										TexAddressModeU[ USE_TEXTURESTAGE_NUM ] ;		// eNX`AhX[ht
	int										TexAddressModeV[ USE_TEXTURESTAGE_NUM ] ;		// eNX`AhX[hu
	int										TexAddressModeW[ USE_TEXTURESTAGE_NUM ] ;		// eNX`AhX[hv
	int										TextureTransformUse[ USE_TEXTURESTAGE_NUM ] ;	// eNX`Wϊsgp邩ǂ( TRUE:gp  FALSE:gpȂ )
	MATRIX									TextureTransformMatrix[ USE_TEXTURESTAGE_NUM ] ;// eNX`Wϊs
	int										UseSpecular ;									// XyLgp邩ǂ
	D_D3DVIEWPORT9							Viewport ;										// r[|[g
	int										ZEnable ;										// yobt@̗LtO
	int										ZFunc ;											// yl̔r[h
	int										ZWriteEnable ;									// yobt@ւ݂̏sAtO
} ;


// Direct3DDevice9 ̕`揈Ɋւ̍\
struct GRAPHICS_HARDDATA_DIRECT3D9_DRAWINFO
{
	BYTE *					VertexBufferNextAddr ;					// ̃f[^i[ׂ_obt@̃AhX
	BYTE *					VertexBufferAddr[ 2 ][ 3 ] ;			// e_obt@ւ̃|C^( [ Rc_ǂ ][ _^Cv ] )
	BYTE					VertexBuffer_NoTex[     D3DDEV_NOTEX_VERTBUFFERSIZE     ] ;	// eNX`gpȂ_obt@
	BYTE					VertexBuffer_Tex[       D3DDEV_TEX_VERTBUFFERSIZE       ] ;	// eNX`gp钸_obt@
	BYTE					VertexBuffer_BlendTex[  D3DDEV_BLENDTEX_VERTBUFFERSIZE  ] ;	// uheNX`gp钸_obt@
	BYTE					VertexBuffer_3D[        D3DDEV_NOTEX_3D_VERTBUFFERSIZE  ] ;	// Rcp_obt@
	int						Use3DVertex ;							// Rc_gpĂ邩ǂ( 1:gpĂ  0:gpĂȂ )
	int						VertexNum ; 							// _obt@Ɋi[Ă钸_̐
	int						VertexType ;							// _obt@Ɋi[Ă钸_f[^( 0:eNX`Ȃ  1:eNX`  2:uheNX` )
	D_D3DPRIMITIVETYPE		PrimitiveType ;							// _obt@Ɋi[Ă钸_f[^̃v~eBu^Cv

	DWORD					DiffuseColor ;							// fBt[YJ[

//	RECT					DrawRect ;								// `͈
	int						BeginSceneFlag ;						// Graphics_D3D9_BeginScene sĂ邩ǂ
	int						BlendMaxNotDrawFlag ;					// uhlőł邱Ƃɂ`sȂǂAtO
} ;


// Direct3DDevice9 ̉ʊ֌W̏̍\
struct GRAPHICS_HARDDATA_DIRECT3D9_SCREENINFO
{
	D_IDirect3DSurface9 *	BackBufferSurface ;						// foCXobNobt@T[tFX
	int						SubBackBufferTextureSizeX ;				// TuobNobt@eNX`̉
	int						SubBackBufferTextureSizeY ;				// TuobNobt@eNX`̏c
	D_IDirect3DTexture9 *	SubBackBufferTexture ;					// ScreenCopy  GetDrawScreen 邽߂Ɏgp`\eNX`
	D_IDirect3DSurface9 *	SubBackBufferSurface ;					// ScreenCopy  GetDrawScreen 邽߂Ɏgp`\T[tFX
	D_IDirect3DSurface9 *	ZBufferSurface ;						// CŎgpyobt@
	int						ZBufferSizeX ;							// yobt@T[tFX̕
	int						ZBufferSizeY ;							// yobt@T[tFX̍
	int						ZBufferBitDepth ;						// yobt@T[tFX̃rbg[x

	D_IDirect3DSurface9 *	DrawScreenBufferLockSMSurface ;			// obNobt@bNۂɒڃbNłȂꍇɎgpT[tFX̃|C^
	int						DrawScreenBufferLockSMSurfaceIndex ;	// obNobt@bNۂɒڃbNłȂꍇɎgpT[tFXLbṼCfbNX
	D_IDirect3DSurface9 *	DrawScreenBufferLockSurface ;			// bNobNobt@

	D_IDirect3DSurface9 *   SaveDrawScreen_SMSurface ;				// SaveDrawScreen ŎgpVXeT[tFX
} ;


// Direct3DDevice9 ̕`ݒɊւ̍\
struct GRAPHICS_HARDDATA_DIRECT3D9_DRAWSETTING
{
	int						DrawPrepParamFlag ;						// O Graphics_D3D9_DrawPreparation ɓƂ ParamFlag p[^
	int						DrawPrepAlwaysFlag ;					// K Graphics_D3D9_DrawPreparation sǂ̃tO

	int						AlphaChannelValidFlag ;					// `lLtO
	int						AlphaTestValidFlag ;					// eXgLtO( Func ͕K D_D3DCMP_GREATEREQUAL )
	int						AlphaTestMode ;							// At@eXg[h
	int						AlphaTestParam ;						// At@eXgp[^
	int						BlendMode ;								// uh[h
	int						ChangeBlendParamFlag ;					// uhݒɊւ镔̕ύXAtO
	int						ChangeTextureFlag ;						// eNX`ύXꂽAtO
	int						IgnoreGraphColorFlag ;					// `悷摜̐F𖳎邩ǂ̃tO
	int						UseDiffuseRGBColor ;					// fBt[YJ[̂qfalgp邩AtO
	int						UseDiffuseAlphaColor ;					// fBt[YJ[̃lgp邩AtO
	int						BlendGraphType ;						// uh摜^Cv
	int						BlendGraphFadeRatio ;					// uh摜̃tF[hp[^
	int						BlendGraphBorderParam ;					// uh摜̋Ep[^(O(uh摜̉eO)@@(uh摜̉eȂ)@@PQW(uh摜̉ePOO)@@(uh摜̉e𒴂Ĕ`敔)@QTT(S`悳Ȃ) )
	int						BlendGraphBorderRange ;					// uh摜̋E(O`QTT@`L@SiK)
	float					BlendTextureWidth ;						// uheNX`̕
	float					BlendTextureHeight ;					// uheNX`̍
	float					InvBlendTextureWidth ;					// uheNX`̋̕t
	float					InvBlendTextureHeight ;					// uheNX`̍̋t

	D_IDirect3DTexture9		*RenderTexture ;						// `掞ɎgpeNX`[
	D_IDirect3DTexture9		*BlendTexture ;							// `掞ɕ`eNX`[ƃuh郿`leNX`[

	int						CancelSettingEqualCheck ;				// ̃tOĂꍇ݂͌̐ݒƕύX̐ݒ肪ǂɊւ炸AKύXs
} ;


// Direct3DDevice9 ֌W̐ݒ̍\
struct GRAPHICS_HARDDATA_DIRECT3D9_DEVICE_SETTING
{
	void					( *DeviceRestoreCallbackFunction)( void *Data ) ;	// foCXXg畜AƂɌĂԊ֐
	void					  *DeviceRestoreCallbackData ;						// foCXXg畜AƂɌĂԊ֐ɓn|C^

	void					( *DeviceLostCallbackFunction)( void *Data ) ;		// foCXXg畜AOɌĂԊ֐
	void					  *DeviceLostCallbackData ;							// foCXXg畜AOɌĂԊ֐ɓn|C^
} ;


// Direct3DDevice9 ̔\͏\
struct GRAPHICS_HARDDATA_DIRECT3D9_DEVICE_CAPS
{
	D_D3DCAPS9				DeviceCaps ;										// foCX

	int						VertexHardwareProcess ;								// _Zn[hEGAŏ邩ǂ( TRUE:  FALSE:Ȃ )
//	int						TextureSizePow2 ;									// eNX`̃TCYQ̂łKv邩ǂ
//	int						TextureSizeNonPow2Conditional ;						// tŃeNX`̃TCYQ̂łȂĂvǂ
//	int						MaxTextureSize ;									// őeNX`TCY
	int						MaxTextureBlendStages ;								// Œ@\pCvCŎgpłőeNX`Xe[W
	int						ValidTexTempRegFlag ;								// eNX`Xe[W̃e|WX^gpł邩ǂ̃tO
	int						ValidDestBlendOp ;									// D3DBLENDOP_ADD ȊOgp\ǂ( TRUE:gp\  FALSE:gps\ )
//	int						RenderTargetNum ;									// ɐݒł郌_O^[Qbg̐
//	int						MaxPrimitiveCount ;									// xɕ`łv~eBu̍ő吔
	int						UseRenderTargetLock ;								// `T[tFX̃bNsǂ( TRUE:s  FALSE:sȂ )
	float					DrawFillCircleLeftVertAddX ;						// hԂ~̕`̍ۂɍ[W x Wɑl
	float					DrawFillCircleRightVertAddX ;						// hԂ~̕`̍ۂɉE[W x Wɑl

#ifndef DX_NON_FILTER
	int						ValidRenderTargetInputTexture ;						// `̓eNX`ƂĎgpł邩ǂ( TRUE:gpł  FALSE:gpłȂ )
#endif // DX_NON_FILTER

	D_D3DFORMAT				ScreenFormat ;										// ʃJ[tH[}bg
	D_D3DFORMAT				TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_NUM ] ;	// eNX`tH[}bg
	D_D3DFORMAT				MaskColorFormat ;									// }XNJ[obt@ptH[}bg
	D_D3DFORMAT				MaskAlphaFormat ;									// }XNAt@`lptH[}bg
	D_D3DFORMAT				ZBufferFormat[ ZBUFFER_FORMAT_NUM ] ;				// yobt@tH[}bg
} ;


// Direct3D9 g`揈Ŏgpf[^̓ Direct3D9Device ̃Zbg
// KvADirect3D9Device ɖڂɊւZ߂\
struct GRAPHICS_HARDDATA_DIRECT3D9_DEVICE
{
	GRAPHICS_HARDDATA_DIRECT3D9_DEVICE_CAPS			Caps ;					// foCX\͏\		

	GRAPHICS_HARDDATA_DIRECT3D9_DEVICE_SETTING		Setting ;				// foCX֌W̐ݒZ߂\

	GRAPHICS_HARDDATA_DIRECT3D9_SCREENINFO			Screen ;				// ʊ֌W̏\

	GRAPHICS_HARDWARE_DIRECT3D9_SHADER				Shader ;				// VF[_[Z߂\

	GRAPHICS_HARDWARE_DIRECT3D9_VERTEXDECLARATION	VertexDeclaration ;		// _VF[_錾Z߂\

	GRAPHICS_HARDDATA_DIRECT3D9_DRAWSETTING			DrawSetting ;			// `ݒɊւZ߂\

	GRAPHICS_HARDDATA_DIRECT3D9_DRAWINFO			DrawInfo ;				// `揈ɊւZ߂\

	GRAPHICS_HARDDATA_DIRECT3D9_DEVICE_STATE		State ;					// Direct3D9Device ɐݒ肵ĂlZ߂\
} ;














// Direct3D9  Qc`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D9_SHADERCODE_2D
{
	int						_2DShaderInitializeFlag ;				// VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

#ifndef DX_NON_NORMAL_DRAW_SHADER
	DXARC					BaseShaderBinDxa ;						// {VF[_[IuWFNgt@Ccw`\
	void					*BaseShaderBinDxaImage ;				// {VF[_[IuWFNgt@Ccw`̃oCiC[W
#endif // DX_NON_NORMAL_DRAW_SHADER

#ifndef DX_NON_FILTER
	DXARC					FilterShaderBinDxa ;					// tB^[VF[_[IuWFNgt@Ccw`\
	void					*FilterShaderBinDxaImage ;				// tB^[VF[_[IuWFNgt@Ccw`̃oCiC[W

	void					*RGBAMixS_ShaderPackImage ;				// RGBAMix  S ̑gݍ킹QTU̃VF[_[pbP[WoCiC[W

	// RGBAMix  S ̑gݍ킹QTU̃VF[_[[ R ][ G ][ B ][ A ]
	void					*RGBAMixS_ShaderAddress[ 4 ][ 4 ][ 4 ][ 4 ] ;
	short					RGBAMixS_ShaderSize[ 4 ][ 4 ][ 4 ][ 4 ] ;
#endif // DX_NON_FILTER
} ;


#ifndef DX_NON_MODEL

// Direct3D9  f`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D9_SHADERCODE_MODEL
{
	volatile int			ModelShaderInitializeFlag ;				// fp̃VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	// CgCfbNXXg
	short					LightIndexList84[ 4 ][ 4 ][ 4 ][ 4 ][ 4 ][ 4 ] ;
	short					LightIndexList20[ 4 ][ 4 ][ 4 ] ;

	short					LightIndexList10[ 3 ][ 3 ][ 3 ] ;

	void					*ModelShaderPackImage ;					// RcfpVF[_[pbP[WoCiC[W

	// f`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	void					*MV1_PixelLighting_VertexShaderAddress[ 2 ][ 3 ][ 2 ][ 4 ] ;

	// f`psNZPʃCeBO^CṽgD[psNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_Oǂ( 0:gD[_O type 1   1:gD[_O Type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	void					*MV1_PixelLighting_ToonPixelShaderAddress[ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 84 ][ 2 ] ;

	// f`psNZPʃCeBO^CṽsNZVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	void					*MV1_PixelLighting_PixelShaderAddress[ 2 ][ 5 ][ 2 ][ 2 ][ 84 ][ 2 ] ;






	// f`p̃gD[_O̗֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	void					*MV1_ToonOutLineVertexShaderAddress[ 3 ][ 4 ] ;

	// f`p̃VhE}bvւ̃_Op_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	void					*MV1_ShadowMapVertexShaderAddress[ 3 ] ;

	// f`p̃CeBOȂ_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ tHO^Cv ]
	void					*MV1_NoLightingVertexShaderAddress[ 3 ][ 4 ] ;

	// f`p̃CeBO蒸_VF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	void					*MV1_LightingVertexShaderAddress[ 2 ][ 2 ][ 3 ][ 2 ][ 4 ][ 20 ][ 2 ] ;


	// f`p̃gD[_O̗֊s`psNZVF[_[
	void					*MV1_ToonOutLinePixelShaderAddress ;

	// f`p̃VhE}bvւ̃gD[_OpsNZVF[_[
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	void					*MV1_ShadowMapToonPixelShaderAddress[ 2 ][ 3 ][ 2 ] ;

	// f`p̃VhE}bvւ̃_OpsNZVF[_[
	void					*MV1_ShadowMapPixelShaderAddress ;

	// f`p̃CeBOȂgD[psNZVF[_[( Xg͔z̍ )
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT or gD[_Oł͂Ȃ  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	void					*MV1_ToonNoLightingPixelShaderAddress[ 2 ][ 2 ] ;

	// f`p̃CeBOȂsNZVF[_[
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	void					*MV1_NoLightingPixelShaderAddress[ 5 ] ;

	// f`p̃CeBOgD[psNZVF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	void					*MV1_ToonLightingPixelShaderAddress[ 2 ][ 2 ][ 2 ][ 3 ][ 2 ][ 2 ][ 2 ][ 2 ][ 10 ][ 2 ] ;

	// f`p̃CeBOsNZVF[_[
	// [ VF[_[f( 0:SM2  1:SM3 )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ XyL}bv ( 0: 1: ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ XyL̗L( 0: 1:L ) ]
	void					*MV1_LightingPixelShaderAddress[ 2 ][ 2 ][ 5 ][ 2 ][ 2 ][ 10 ][ 2 ] ;
} ;

#endif // DX_NON_MODEL


// VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_DIRECT3D9_SHADERCODE
{
	GRAPHICS_HARDWARE_DIRECT3D9_SHADERCODE_2D		_2D ;				// Qc`揈p̃VF[_[R[hZ߂\

#ifndef DX_NON_MODEL
	GRAPHICS_HARDWARE_DIRECT3D9_SHADERCODE_MODEL	Model ;				// f`揈p̃VF[_[R[hZ߂\
#endif // DX_NON_MODEL
} ;


// A_v^[֌W\
struct GRAPHICS_HARDWARE_DIRECT3D9_ADAPTER
{
	int												ValidInfo ;					// A_v^̏񂪗Lǂ( TRUE:L  FALSE: )
	int												InfoNum ;					// A_v^̐
	D_D3DADAPTER_IDENTIFIER9						Info[ DX_D3D9_MAX_DEVICE_LISTUP ] ;	// A_v^̏

//	int												ValidUseAdapterNumber ;		// UseAdapterNumber Lǂ( TRUE:L  FALSE: )
//	int												UseAdapterNumber ;			// gpfoCXA_v^ԍ
} ;


// Direct3D9 ֌W̐ݒ̍\
struct GRAPHICS_HARDDATA_DIRECT3D9_SETTING
{
	int						NotUseDirect3D9Ex ;						// Direct3D9Ex gpȂǂ
	int						UseMultiThread ;						// }`XbhΉtOgǂ
	int						NonUseVertexHardwareProcess ;			// Iɒ_Zn[hEGAŏȂǂ( TRUE:Ȃ  FALSE: )
//	int						DisableAeroFlag ;						// Aero 𖳌ɂ邩ǂ̃tO( TRUE:ɂ  FALSE:ɂȂ )
//	D_D3DMULTISAMPLE_TYPE	FSAAMultiSampleType ;					// FSAAp}`TvO^Cv
//	int						FSAAMultiSampleQuality ;				// FSAAp}`TvONIeB
	int						UseOldDrawModiGraphCodeFlag ;			// ȑO DrawModiGraph ֐R[hgp邩ǂ̃tO
	int						UserZBufferSizeSet ;					// Oyobt@TCY̎w肪ǂ
	int						UserZBufferBitDepthSet ;				// Oyobt@̃rbg[xw肪ǂ
} ;


// ǗeNX`ւ̃f[^]pVXezueNX`̏
struct GRAPHICS_HARDDATA_DIRECT3D9_SYSMEMTEXTURE
{
	unsigned char					InitializeFlag ;						// gp\ȏԂǂ̃tO
	unsigned char					UseFlag ;								// gpǂ̃tO
	unsigned char					CubeMap ;								// L[u}bvǂ( 1:L[u}bveNX`  0:ʏeNX` )
	unsigned char					MipMapCount ;							// ~bv}bv̐
	short							Width ;									// 
	short							Height ;								// 
	D_D3DFORMAT						Format ;								// tH[}bg
	unsigned int					UseCount ;								// gp
	int								UseTime ;								// ŌɎgp
	D_IDirect3DBaseTexture9	*		MemTexture ;							// VXeeNX`
} ;


// ǗeNX`ւ̃f[^]pVXezuT[tFX̏
struct GRAPHICS_HARDDATA_DIRECT3D9_SYSMEMSURFACE
{
	unsigned char					InitializeFlag ;						// gp\ȏԂǂ̃tO
	unsigned char					UseFlag ;								// gpǂ̃tO
	short							Width ;									// 
	short							Height ;								// 
	D_D3DFORMAT						Format ;								// tH[}bg
	unsigned int					UseCount ;								// gp
	int								UseTime ;								// ŌɎgp
	D_IDirect3DSurface9	*			MemSurface ;							// VXeT[tFX
} ;


// Direct3D9 ̃VXeeNX`ET[tFX̍\
struct GRAPHICS_HARDDATA_DIRECT3D9_SYSMEM_TEX_SURF
{
	GRAPHICS_HARDDATA_DIRECT3D9_SYSMEMTEXTURE		Texture[ DIRECT3D9_SYSMEMTEXTURE_NUM ] ;	// ǗeNX`ւ̃f[^]pVXezueNX`
	int												TextureInitNum ;				// ς݂̃VXeeNX`̐

	GRAPHICS_HARDDATA_DIRECT3D9_SYSMEMSURFACE		Surface[ DIRECT3D9_SYSMEMSURFACE_NUM ] ;	// ǗeNX`ւ̃f[^]pVXezuT[tFX
	int												SurfaceInitNum ;				// ς݂̃VXeT[tFX̐
} ;


// Direct3D9 gOtBbNX̍\
struct GRAPHICS_HARDDATA_DIRECT3D9
{
//	int												NormalDraw_UseVertexShader ;	// ʏ`ɒ_VF[_[gp邩ǂ( TRUE:gp  FALSE:gpȂ )
	int												NormalDraw_NotUsePixelShader ;	// ʏ`ɃsNZVF[_[gpȂǂ( TRUE:gpȂ  FALSE:gp )
	int												UsePixelLightingShader ;	// sNZPʂŃCeBOs^CṽVF[_[gp邩ǂ( TRUE:gp  FALSE:gpȂ )

#ifndef DX_NON_MODEL
	D_IDirect3DVolumeTexture9 *						RGBtoVMaxRGBVolumeTexture ;	// RGBJ[PxőɂRGBlɕϊ邽߂̃{[eNX`
#endif // DX_NON_MODEL

	GRAPHICS_HARDDATA_DIRECT3D9_SETTING				Setting ;					// Direct3D9 ֌W̐ݒ

	GRAPHICS_HARDDATA_DIRECT3D9_DEVICE				Device ;					// Direct3D9Device ɖڂɊ֘A

	GRAPHICS_HARDWARE_DIRECT3D9_ADAPTER				Adapter ;					// A_v^[֌W

	GRAPHICS_HARDWARE_DIRECT3D9_SHADERCODE			ShaderCode ;				// D_IDirect3DPixelShader9  D_IDirect3DVertexShader9 ̌ƂȂVF[_[R[hf[^Z߂\

	GRAPHICS_HARDDATA_DIRECT3D9_SYSMEM_TEX_SURF		SysMemTexSurf ;				// VXeeNX`ET[tFX
} ;


// ϐ錾 --------------------------------------------------------------

extern GRAPHICS_HARDDATA_DIRECT3D9 GraphicsHardDataDirect3D9 ;

// ֐vg^Cv錾-----------------------------------------------------------


// Direct3D9 ̏֌W
extern	int		Graphics_D3D9_Initialize( void ) ;								// Direct3D9 gpOtBbNX̏s( 0: -1:s )
extern	int		Graphics_D3D9_Terminate( void ) ;								// Direct3D9 gpOtBbNX̌ns

extern	int		Graphics_D3D9_ReleaseObjectAll( void ) ;						// ׂĂ Direct3D9 nIuWFNg
extern	int		Graphics_D3D9_CreateObjectAll( void ) ;							// ׂĂ Direct3D9 nIuWFNg쐬

extern	int		Graphics_D3D9_SetupRenderTargetInputTextureFlag( void ) ;		// sNZVF[_[gpꍇ͏o͐eNX`ƂĎgpł邩ǂ̃`FbNs








// VF[_[R[h֌W
extern	int		Graphics_D3D9_ShaderCode_2D_Initialize( void ) ;				// Direct3D9 ̂Qc`p̃VF[_[R[h̏s
extern	int		Graphics_D3D9_ShaderCode_2D_Terminate( void ) ;					// Direct3D9 ̂Qc`p̃VF[_[R[ȟns

#ifndef DX_NON_MODEL

extern	int		Graphics_D3D9_ShaderCode_Model_Initialize( void ) ;				// Direct3D9 ̃f`p̃VF[_[R[h̏s
extern	int		Graphics_D3D9_ShaderCode_Model_Terminate( void ) ;				// Direct3D9 ̃f`p̃VF[_[R[ȟns

extern	int		Graphics_D3D9_Shader_Model_Setup( int VertexShaderIndex, int VertexShaderIndex_PL, int PixelShaderIndex, int PixelShaderIndex_PL ) ;		// w̃f`pVF[_[ZbgAbv( TRUE:  FALSE:s )

#endif // DX_NON_MODEL

extern	int		Graphics_D3D9_Shader_Initialize( void ) ;						// Direct3D9 ̃VF[_[̏s
extern	int		Graphics_D3D9_Shader_Terminate( void ) ;						// Direct3D9 ̃VF[_[̌n

extern	void	Graphics_D3D9_Shader_RefreshUseIndex( void ) ;					// gpVF[_[̃CfbNX̒lXV

extern	D_D3DXSHADER_CONSTANTINFO *Graphics_D3D9_GetShaderConstInfo( SHADERHANDLEDATA *Shader, const wchar_t *ConstantName ) ;				// VF[_[̒萔𓾂








// _obt@ECfbNXobt@֌W
extern	int		Graphics_D3D9_VertexBuffer_CreateObject(  VERTEXBUFFERHANDLEDATA *VertexBuffer, int Restore ) ;	// _obt@nhp Direct3DVertexBuffer9 IuWFNg쐬
extern	int		Graphics_D3D9_VertexBuffer_ReleaseObject( VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;				// _obt@nhp Direct3DVertexBuffer9 IuWFNg
extern	int		Graphics_D3D9_IndexBuffer_CreateObject(   INDEXBUFFERHANDLEDATA *IndexBuffer,   int Restore ) ;	// CfbNXobt@nhp Direct3DIndexBuffer9 IuWFNg쐬
extern	int		Graphics_D3D9_IndexBuffer_ReleaseObject(  INDEXBUFFERHANDLEDATA *IndexBuffer ) ;				// CfbNXobt@nhp Direct3DIndexBuffer9 IuWFNg








// Direct3D9 ̉ʊ֌W
extern	int		Graphics_D3D9_SetupSubBackBuffer( void ) ;						// TuobNobt@gp鏀s( 0:  -1:s )
extern	int		Graphics_D3D9_CreateZBuffer( void ) ;							// yobt@IuWFNg̍쐬( 0:  -1:s )








// Direct3D9 ̉摜֌W
extern COLORDATA *Graphics_D3D9_GetD3DFormatColorData( D_D3DFORMAT Format ) ;									// D3DFORMAT ̃tH[}bgɍ킹J[tH[}bg擾
extern	int		Graphics_D3D9_UpdateDrawTexture( IMAGEDATA_ORIG_HARD_TEX *OrigTex, int TargetSurface ) ;		// `peNX`ƕ`peNX`ĂꍇɁA`peNX`ɕ`peNX`̓e𔽉f

// {C[W̃tH[}bg DX_BASEIMAGE_FORMAT_NORMAL ɕϊKv邩ǂ`FbN
// ( RequiredRgbBaseImageConvFlag  RequiredAlphaBaseImageConvFlag ɓl  TRUE:ϊKv  FALSE:ϊKv͖ )
extern	int		Graphics_D3D9_CheckRequiredNormalImageConv_BaseImageFormat_PF(
	IMAGEDATA_ORIG *Orig,
	int             RgbBaseImageFormat,
	int            *RequiredRgbBaseImageConvFlag,
	int             AlphaBaseImageFormat = -1,
	int            *RequiredAlphaBaseImageConvFlag = NULL
) ;








// Direct3DDevice ̏֌W
extern	int		Graphics_D3D9_Device_Create( void ) ;																// Direct3DDevice9 IuWFNg̍쐬( 0:  -1:s )

extern	int		Graphics_D3D9_Device_Initialize( void ) ;															// Direct3DDevice9 ֌W̏
extern	int		Graphics_D3D9_Device_ReInitialize( void ) ;															// ꎞI Direct3DDevice9 jۂɁAjȌԂo߂̊֐








// Direct3DDevice9 Xe[^X֌W
extern	void	Graphics_D3D9_DeviceState_RefreshRenderState( void ) ;												// `ݒtbV
extern	int		Graphics_D3D9_DeviceState_SetBaseState( void ) ;													// Direct3DDevice9 ̊{ݒs
extern	int		Graphics_D3D9_DeviceState_SetSampleFilterMode( int Sampler, int SetTarget, D_D3DTEXTUREFILTERTYPE FilterType ) ;		// Tv[̃eNX`tB^O[hݒ肷
extern	int		Graphics_D3D9_DeviceState_SetZEnable( int Flag )  ;													// yobt@̗L̃Zbg
extern	int		Graphics_D3D9_DeviceState_SetZWriteEnable( int Flag ) ;												// yobt@݂̗̏LZbg
extern	int		Graphics_D3D9_DeviceState_SetZFunc( int CmpType ) ;													// [xl̔r^CvZbg
extern	int		Graphics_D3D9_DeviceState_SetDepthBias( int Bias ) ;												// [xl̃oCAXZbg
extern	int		Graphics_D3D9_DeviceState_SetFillMode( int FillMode ) ;												// tB[hZbg
extern	int		Graphics_D3D9_DeviceState_SetWorldMatrix( const MATRIX *Matrix ) ;									// [hϊpsZbg
extern	int		Graphics_D3D9_DeviceState_SetViewMatrix( const MATRIX *Matrix ) ;									// r[ϊpsZbg
extern	int		Graphics_D3D9_DeviceState_SetProjectionMatrix( const MATRIX *Matrix ) ;								// eϊpsZbg
extern	int		Graphics_D3D9_DeviceState_SetLightState( int LightNumber, D_D3DLIGHT9 *Light ) ;					// Cg̃Zbg
extern	int		Graphics_D3D9_DeviceState_SetLightEnable( int LightNumber, int EnableState ) ;						// Cg̗LAύX
extern	int		Graphics_D3D9_DeviceState_SetMaterial( D_D3DMATERIAL9 *Material ) ;									// }eÃZbg
extern	int		Graphics_D3D9_DeviceState_SetSpecularEnable( int UseFlag ) ;										// XyLgp邩ǂZbg
extern	int		Graphics_D3D9_DeviceState_SetDiffuseMaterialSource( int UseFlag ) ;									// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂݒ肷
extern	int		Graphics_D3D9_DeviceState_SetSpecularMaterialSource( int UseFlag ) ;								// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂݒ肷
extern	int		Graphics_D3D9_DeviceState_SetCullMode( int State ) ;												// JO̗LZbg 
extern	int		Graphics_D3D9_DeviceState_SetAmbient( unsigned int Color ) ;										// ArGgJ[̃Zbg
extern	int		Graphics_D3D9_DeviceState_SetShadeMode( int ShadeMode ) ;											// VF[fBO[h̃Zbg
extern	int		Graphics_D3D9_DeviceState_SetTextureAddress( int AddressMode, int Sampler = -1 ) ;					// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D9_DeviceState_SetTextureAddressU( int AddressMode, int Sampler = -1 ) ;					// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D9_DeviceState_SetTextureAddressV( int AddressMode, int Sampler = -1 ) ;					// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D9_DeviceState_SetTextureAddressW( int AddressMode, int Sampler = -1 ) ;					// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D9_DeviceState_SetTextureAddressUVW( int AddressModeU, int AddressModeV, int AddressModeW, int Sampler = -1 ) ;		// eNX`[̃AhbVO[hZbg
extern	int		Graphics_D3D9_DeviceState_SetTextureAddressTransformMatrix( int Use, MATRIX *Matrix, int Samplar = -1 ) ;	// eNX`WϊsZbg
extern	int		Graphics_D3D9_DeviceState_SetFogEnable( int Flag ) ;												// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_D3D9_DeviceState_SetFogVertexMode( int Mode /* DX_FOGMODE_NONE  */ ) ;					// tHO[hݒ肷
extern	int		Graphics_D3D9_DeviceState_SetFogColor( unsigned int Color ) ;										// tHOJ[ύX
extern	int		Graphics_D3D9_DeviceState_SetFogStartEnd( float Start, float End ) ;								// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_D3D9_DeviceState_SetFogDensity( float Density ) ;											// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_D3D9_DeviceState_SetLighting( int Flag ) ;													// Cg̗LtOZbg
extern	int		Graphics_D3D9_DeviceState_SetMaxAnisotropy( int MaxAnisotropy, int Sampler = -1 ) ;					// őٕZbg
extern	int		Graphics_D3D9_DeviceState_SetViewport( D_D3DVIEWPORT9 *Viewport ) ;									// r[|[gZbg
extern	int		Graphics_D3D9_DeviceState_SetViewportEasy( int x1, int y1, int x2, int y2 ) ;						// r[|[gZbg( ȈՔ )
extern	int		Graphics_D3D9_DeviceState_SetScissorRect( RECT *Rect ) ;											// VU[`ݒ肷
extern	int		Graphics_D3D9_DeviceState_SetDrawMode( int DrawMode ) ;												// `惂[h̃Zbg
extern	int		Graphics_D3D9_DeviceState_SetRenderTarget( D_IDirect3DSurface9 *TargetSurface, int TargetIndex = 0 ) ;	// `Ώۂ̕ύX
extern	int		Graphics_D3D9_DeviceState_SetFVF( int FVF ) ;														// gpFVFύX
extern	int		Graphics_D3D9_DeviceState_SetVertexDeclaration( D_IDirect3DVertexDeclaration9 *VertexDeclaration ) ;	// gp钸_VF[_錾ύX
#ifndef DX_NON_MODEL
extern	int		Graphics_D3D9_DeviceState_SetMV1VertexDeclaration( int BumpMap, int SkinMesh, int UVNum ) ;			// w̃fp̒_VF[_錾Zbg
#endif // DX_NON_MODEL
extern	int		Graphics_D3D9_DeviceState_SetVertexShaderToHandle( int ShaderHandle ) ;								// w̒_VF[_[foCXɃZbg
extern	int		Graphics_D3D9_DeviceState_SetVertexShader( D_IDirect3DVertexShader9 *VertexShader, int NormalVertexShader = FALSE ) ;	// gp钸_VF[_[ύX
extern	int		Graphics_D3D9_DeviceState_ResetVertexShader( int SetNormalVertexShaderCancel = FALSE ) ;			// _VF[_[̎gp~߂( Œ@\pCvCgpԂɂ )
extern	int		Graphics_D3D9_DeviceState_SetPixelShaderToHandle( int ShaderHandle ) ;								// w̃sNZVF[_[foCXɃZbg
extern	int		Graphics_D3D9_DeviceState_SetPixelShader( D_IDirect3DPixelShader9 *PixelShader, int NormalPixelShader = FALSE ) ;	// gpsNZVF[_[ύX
extern	int		Graphics_D3D9_DeviceState_ResetPixelShader( int SetNormalPixelShaderCancel = FALSE ) ;				// sNZVF[_[̎gp~߂( Œ@\pCvCgpԂɂ )
extern	int		Graphics_D3D9_DeviceState_SetVertexBuffer( D_IDirect3DVertexBuffer9 *VertexBuffer, int VertexStride = 0 ) ;	// gp钸_obt@ύX
extern	int		Graphics_D3D9_DeviceState_SetIndexBuffer( D_IDirect3DIndexBuffer9 *IndexBuffer ) ;					// gpCfbNXobt@ύX
extern	int		Graphics_D3D9_DeviceState_ResetTextureCoord( void ) ;												// eXe[WgpeNX`AhXXe[WԍƓɂ
extern	int		Graphics_D3D9_DeviceState_SetUserBlendInfo(  GRAPHICS_HARDDATA_DIRECT3D9_BLENDINFO *BlendInfo, int TextureStageIsTextureAndTextureCoordOnlyFlag, int TextureIsGraphHandleFlag = TRUE, int UseShader = TRUE ) ;					// [U[̃uhCtHK
extern	int		Graphics_D3D9_DeviceState_RefreshBlendState( GRAPHICS_HARDDATA_DIRECT3D9_BLENDINFO *pUserInfo = NULL, int TextureStageIsTextureAndTextureCoordOnlyFlag = FALSE, int TextureIsGraphHandleFlag = TRUE, int UseShader = TRUE ) ;	// uhݒXV(Direct3D ɔf)
extern	void	Graphics_D3D9_DeviceState_RefreshAmbientAndEmissiveParam( void ) ;									// ArGgCgƃG~bVuJ[|킹p[^XV








// `ݒ֌W֐
extern	int		Graphics_D3D9_DrawSetting_SetDrawBlendMode( int BlendMode, int AlphaTestValidFlag, int AlphaChannelValidFlag ) ;	// `uh[h̐ݒ
extern	int		Graphics_D3D9_DrawSetting_SetIgnoreDrawGraphColor( int EnableFlag ) ;							// `掞̉摜̐F𖳎邩ǂݒ肷
extern	int		Graphics_D3D9_DrawSetting_SetDrawAlphaTest( int TestMode, int TestParam ) ;					// At@eXg̐ݒ
extern	int		Graphics_D3D9_DrawSetting_SetUseDiffuseAlphaColorFlag( int UseFlag ) ;						// fBt[YJ[̃lgp邩ǂtOZbg
extern	int		Graphics_D3D9_DrawSetting_SetUseDiffuseRGBColorFlag( int UseFlag ) ;							// fBt[YJ[̂qfalgp邩ǂtOZbg
extern	int		Graphics_D3D9_DrawSetting_SetBlendTextureParam( int BlendType, int *Param ) ;					// uheNX`̃p[^Zbg
extern	int		Graphics_D3D9_DrawSetting_SetTexture( D_IDirect3DTexture9 *RenderTexture ) ;					// eNX`Zbg 
extern	int		Graphics_D3D9_DrawSetting_SetBlendTexture( D_IDirect3DTexture9 *BlendTexture, int TexWidth = -1, int TexHeight = -1 ) ;	// uheNX`Zbg 








// VF[_[萔Ǘ\̏֐
extern	int		Graphics_D3D9_ShaderConstant_UseArea_Initialize(  DIRECT3D9_SHADERCONSTANT_USEAREA *UseArea, int TotalSize ) ;															// VF[_[萔gp̈
extern	int		Graphics_D3D9_ShaderConstant_UseArea_Set(         DIRECT3D9_SHADERCONSTANT_USEAREA *UseArea, int IsUse, int Index, int Num ) ;											// VF[_[萔gp̈ύX
extern	int		Graphics_D3D9_ShaderConstant_UseArea_Create(      DIRECT3D9_SHADERCONSTANT_USEAREA *UseArea, BYTE *Map, BYTE SetNumber ) ;												// VF[_[萔gp̈񂩂gp}bv쐬

extern	int		Graphics_D3D9_ShaderConstant_InfoSet_Initialize(  DIRECT3D9_SHADERCONSTANTINFOSET *ConstInfoSet ) ;																		// VF[_[萔̏
extern	int		Graphics_D3D9_ShaderConstant_InfoSet_SetUseState( DIRECT3D9_SHADERCONSTANTINFOSET *ConstInfoSet, int ApplyMask ) ;														// w̃VF[_[萔ZbgKp邩ǂݒ肷 DX_SHADERCONSTANTSET_MASK_LIB | DX_SHADERCONSTANTSET_MASK_LIB_SUB 
extern	int		Graphics_D3D9_ShaderConstant_InfoSet_SetParam(    DIRECT3D9_SHADERCONSTANTINFOSET *ConstInfoSet, int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea ) ;	// VF[_[萔ݒ肷
extern	int		Graphics_D3D9_ShaderConstant_InfoSet_ResetParam(  DIRECT3D9_SHADERCONSTANTINFOSET *ConstInfoSet, int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum ) ;										// ẅ̃VF[_[萔Zbg








// _VF[_錾֌W֐
extern	int		Graphics_D3D9_VertexDeclaration_Create( void ) ;		// Direct3DVertexDeclaration9 IuWFNg̍쐬( 0:  -1:s )
extern	int		Graphics_D3D9_VertexDeclaration_Terminate( void ) ;		// Direct3DVertexDeclaration9 IuWFNg̍폜( 0:  -1:s )








// VXeeNX`ET[tFX֌W֐
extern	int		Graphics_D3D9_GetSysMemTextureFromOrig( struct IMAGEDATA_ORIG *Orig, struct IMAGEDATA_ORIG_HARD_TEX *OrigTex, int ASyncThread = FALSE ) ;		// IMAGEDATA_ORIG  IMAGEDATA_ORIG_HARD_TEX ̏ Graphics_D3D9_GetSysMemTexture gp
extern	int		Graphics_D3D9_GetSysMemTexture( int CubeMap, int Width, int Height, int MipMapCount, D_D3DFORMAT Format, int ASyncThread ) ;		// ǗeNX`ւ̓]p̃VXeeNX`擾
extern	int		Graphics_D3D9_GetSysMemSurface( int Width, int Height, D_D3DFORMAT Format, int ASyncThread ) ;										// ǗeNX`ւ̓]p̃VXeT[tFX擾
extern	int		Graphics_D3D9_CreateSysMemTextureDirect3D9Texture( GRAPHICS_HARDDATA_DIRECT3D9_SYSMEMTEXTURE *MemTex ) ;							// \̂̃f[^ɓ]p̃VXeeNX`쐬
extern	int		Graphics_D3D9_CreateSysMemSurfaceDirect3D9Surface( GRAPHICS_HARDDATA_DIRECT3D9_SYSMEMSURFACE *MemSurface ) ;						// \̂̃f[^ɓ]p̃VXeT[tFX쐬
extern	int		Graphics_D3D9_ReleaseSysMemTexture( int Index, int ASyncThread = FALSE ) ;															// ǗeNX`ւ̓]p̃VXeeNX`
extern	int		Graphics_D3D9_ReleaseSysMemSurface( int Index, int ASyncThread = FALSE ) ;															// ǗeNX`ւ̓]p̃VXeT[tFX
extern	int		Graphics_D3D9_ReleaseSysMemTextureAll( int IsNotUseOnly = FALSE ) ;																	// ǗeNX`ւ̓]p̃VXeeNX`ׂĉ
extern	int		Graphics_D3D9_ReleaseSysMemSurfaceAll( int IsNotUseOnly = FALSE ) ;																	// ǗeNX`ւ̓]p̃VXeT[tFXׂĉ

extern	int		Graphics_D3D9_SysMemTextureProcess( void ) ;																						// ǗeNX`ւ̓]p̃VXeeNX`̒s
extern	int		Graphics_D3D9_SysMemSurfaceProcess( void ) ;																						// ǗeNX`ւ̓]p̃VXeT[tFX̒s








// Direct3D9 ̕`揈֌W
extern	int		Graphics_D3D9_RenderVertex( int ASyncThread = FALSE ) ;							// _obt@ɗ܂_f[^_O
extern	void	FASTCALL Graphics_D3D9_DrawPreparation( int ParamFlag = 0 ) ;					// `揀s
extern	void	Graphics_D3D9_BeginScene( void ) ;												// rMV[s
extern	void	Graphics_D3D9_EndScene( void ) ;												// GhV[s	








// Direct3D9 g`֌W
extern	int		Graphics_D3D9_DrawBillboard3D( VECTOR Pos, float cx, float cy, float Size, float Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawBillboard3D
extern	int		Graphics_D3D9_DrawModiBillboard3D( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawModiBillboard3D
extern	int		Graphics_D3D9_DrawGraph( int x, int y, float xf, float yf, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag ) ;																// n[hEGAANZ[^gp DrawGraph
extern	int		Graphics_D3D9_DrawExtendGraph( int x1, int y1, int x2, int y2, float x1f, float y1f, float x2f, float y2f, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag ) ;				// n[hEGAANZ[^gp DrawExtendGraph
extern	int		Graphics_D3D9_DrawRotaGraph( int x, int y, float xf, float yf, double ExRate, double Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int IntFlag ) ;				// n[hEGAANZ[^gp DrawRotaGraph
extern	int		Graphics_D3D9_DrawModiGraph( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag ) ;					// n[hEGAANZ[^gp DrawModiGraph
extern	int		Graphics_D3D9_DrawModiGraphF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag ) ;	// n[hEGAANZ[^gp DrawModiGraphF
extern	void	Graphics_D3D9_DrawModiTex( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA_HARD_DRAW *DrawTex, bool SimpleDrawFlag ) ;								// eNX`ό`ĕ`悷
extern	int		Graphics_D3D9_DrawSimpleTwoTriangleGraphF( const GRAPHICS_DRAW_DRAWSIMPLETWOTRIANGLEGRAPHF_PARAM *Param, IMAGEDATA *Image, IMAGEDATA *BlendImage ) ;											// n[hEGAANZ[^gp DrawSimpleTwoTriangleGraphF

extern	int		Graphics_D3D9_DrawFillBox( int x1, int y1, int x2, int y2, unsigned int Color ) ;																		// n[hEGAANZ[^gp DrawFillBox
extern	int		Graphics_D3D9_DrawLineBox( int x1, int y1, int x2, int y2, unsigned int Color ) ;																		// n[hEGAANZ[^gp DrawLineBox
extern	int		Graphics_D3D9_DrawLine( int x1, int y1, int x2, int y2, unsigned int Color ) ;																			// n[hEGAANZ[^gp DrawLine
extern	int		Graphics_D3D9_DrawLine3D( VECTOR Pos1, VECTOR Pos2, unsigned int Color, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;									// n[hEGAANZ[^gp DrawLine3D
extern	int		Graphics_D3D9_DrawCircle_Thickness( int x, int y, int r, unsigned int Color, int Thickness ) ;															// n[hEGAANZ[^gp DrawCircle( w肠 )
extern	int		Graphics_D3D9_DrawOval_Thickness( int x, int y, int rx, int ry, unsigned int Color, int Thickness ) ;													// n[hEGAANZ[^gp DrawOval( w肠 )
extern	int		Graphics_D3D9_DrawCircle( int x, int y, int r, unsigned int Color, int FillFlag ) ;																		// n[hEGAANZ[^gp DrawCircle
extern	int		Graphics_D3D9_DrawOval( int x, int y, int rx, int ry, unsigned int Color, int FillFlag ) ;																// n[hEGAANZ[^gp DrawOval
extern	int		Graphics_D3D9_DrawTriangle( int x1, int y1, int x2, int y2, int x3, int y3, unsigned int Color, int FillFlag ) ;										// n[hEGAANZ[^gp DrawTriangle
extern	int		Graphics_D3D9_DrawTriangle3D( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, unsigned int Color, int FillFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawTriangle3D
extern	int		Graphics_D3D9_DrawQuadrangle( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, unsigned int Color, int FillFlag ) ;						// n[hEGAANZ[^gp DrawQuadrangle
extern	int		Graphics_D3D9_DrawPixel( int x, int y, unsigned int Color ) ;																							// n[hEGAANZ[^gp DrawPixel
extern	int		Graphics_D3D9_DrawPixel3D( VECTOR Pos, unsigned int Color, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;												// n[hEGAANZ[^gp DrawPixel3D
extern	int		Graphics_D3D9_DrawPixelSet( const POINTDATA *PointData, int Num ) ;																						// n[hEGAANZ[^gp DrawPixelSet
extern	int		Graphics_D3D9_DrawLineSet( const LINEDATA *LineData, int Num ) ;																						// n[hEGAANZ[^gp DrawLineSet

extern	int		Graphics_D3D9_DrawPrimitive(                             const VERTEX_3D *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D9_DrawIndexedPrimitive(                      const VERTEX_3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D9_DrawPrimitiveLight(                        const VERTEX3D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D9_DrawIndexedPrimitiveLight(                 const VERTEX3D  *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D9_DrawPrimitiveLight_UseVertexBuffer(        VERTEXBUFFERHANDLEDATA *VertexBuffer,                                      int PrimitiveType,                 int StartVertex, int UseVertexNum, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D9_DrawIndexedPrimitiveLight_UseVertexBuffer( VERTEXBUFFERHANDLEDATA *VertexBuffer, INDEXBUFFERHANDLEDATA *IndexBuffer,  int PrimitiveType, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum, IMAGEDATA *Image, int TransFlag ) ;
extern	int		Graphics_D3D9_DrawPrimitive2D(                                 VERTEX_2D *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int BillboardFlag, int Is3D, int TurnFlag, int TextureNo ) ;
extern	int		Graphics_D3D9_DrawPrimitive2DUser(                       const VERTEX2D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo ) ;
extern	int		Graphics_D3D9_DrawIndexedPrimitive2DUser(                const VERTEX2D  *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag ) ;

extern	void	Graphics_D3D9_DrawPreparationToShader( int ParamFlag, int UseVertexShaderNo, int Is2D, int UseLibSubShaderConst ) ;							// VF[_[`p`OZbgAbv֐

extern	int		Graphics_D3D9_DrawPrimitive2DToShader(        const VERTEX2DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂQcv~eBu`悷
extern	int		Graphics_D3D9_DrawPrimitive3DToShader(        const VERTEX3DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂRcv~eBu`悷
extern	int		Graphics_D3D9_DrawPrimitiveIndexed2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂQcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_D3D9_DrawPrimitiveIndexed3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;		// VF[_[gĂRcv~eBu`悷( _CfbNXgp )

extern	int		Graphics_D3D9_DrawPrimitive3DToShader_UseVertexBuffer2(        int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum ) ;	// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_D3D9_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum ) ;	// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )








// ˑ֌W
extern	int		Graphics_D3D9_Initialize_Timing0_PF( void ) ;											// `揈̊ˑ̏s֐( sӏʂO )
extern	int		Graphics_D3D9_Initialize_Timing1_PF( void ) ;											// `揈̊ˑ̏s֐( sӏʂQ )
extern	int		Graphics_D3D9_Hardware_Initialize_PF( void ) ;											// n[hEGAANZ[^gpꍇ̊ˑ̏s
extern	int		Graphics_D3D9_Terminate_PF( void ) ;													// `揈̊ˑ̌ns֐
extern	int		Graphics_D3D9_RestoreOrChangeSetupGraphSystem_PF( int Change, int ScreenSizeX = -1, int ScreenSizeY = -1, int ColorBitDepth = -1, int RefreshRate = -1 ) ;		// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs
extern	int		Graphics_D3D9_Hardware_CheckValid_PF( void ) ;											// `pfoCXLǂ擾( ߂l  TRUE:L  FALSE: )
extern	void	Graphics_D3D9_ReleaseDirectXObject_PF( void ) ;											// DirectX ̃IuWFNg








// ˑVXe֌W
extern	void	Graphics_D3D9_WM_ACTIVATE_ActiveProcess_PF( void ) ;									// WM_ACTIVATE bZ[W̏ŁAEChE[hɃANeBuɂȂۂɌĂ΂֐









// ˑ`ݒ֌W
extern	int		Graphics_Hardware_D3D9_SetRenderTargetToShader_PF( int TargetIndex, int DrawScreen, int SurfaceIndex ) ;	// VF[_[`ł̕`ݒ肷
extern	int		Graphics_Hardware_D3D9_SetDrawBrightToOneParam_PF( DWORD Bright ) ;											// SetDrawBright ̈
extern	int		Graphics_Hardware_D3D9_SetDrawBlendMode_PF( int BlendMode, int BlendParam ) ;								// `uh[hZbg
extern	int		Graphics_Hardware_D3D9_SetDrawAlphaTest_PF( int TestMode, int TestParam ) ;									// `掞̃At@eXg̐ݒs( TestMode:DX_CMP_GREATER( -1:ftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl )
extern	int		Graphics_Hardware_D3D9_SetDrawMode_PF( int DrawMode ) ;														// `惂[hZbg
extern	int		Graphics_Hardware_D3D9_SetDrawBright_PF( int RedBright, int GreenBright, int BlueBright ) ;					// `PxZbg
extern	int		Graphics_Hardware_D3D9_SetBlendGraphParamBase_PF( IMAGEDATA *BlendImage, int BlendType, int *Param ) ;		// SetBlendGraphParam ̉ϒp[^t
extern	int		Graphics_Hardware_D3D9_SetMaxAnisotropy_PF( int MaxAnisotropy ) ;											// őٕ̒lZbg
extern	int		Graphics_Hardware_D3D9_SetTransformToWorld_PF( const MATRIX *Matrix ) ;										// [hϊpsZbg
extern	int		Graphics_Hardware_D3D9_SetTransformToView_PF( const MATRIX *Matrix ) ;										// r[ϊpsZbg
extern	int		Graphics_Hardware_D3D9_SetTransformToProjection_PF( const MATRIX *Matrix ) ;								// eϊpsZbg
extern	int		Graphics_Hardware_D3D9_SetTransformToViewport_PF( const MATRIX *Matrix ) ;									// r[|[gsZbg
extern	int		Graphics_Hardware_D3D9_SetTextureAddressMode_PF( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage ) ;		// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D9_SetTextureAddressModeUV_PF( int ModeU, int ModeV, int Stage ) ;						// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D9_SetTextureAddressTransformMatrix_PF( int UseFlag, MATRIX *Matrix, int Sampler = -1 ) ;// eNX`WϊsZbg
extern	int		Graphics_Hardware_D3D9_SetFogEnable_PF( int Flag ) ;														// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_Hardware_D3D9_SetFogMode_PF( int Mode /* DX_FOGMODE_NONE  */ ) ;									// tHO[hݒ肷
extern	int		Graphics_Hardware_D3D9_SetFogColor_PF( DWORD FogColor ) ;													// tHOJ[ύX
extern	int		Graphics_Hardware_D3D9_SetFogStartEnd_PF( float start, float end ) ;										// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D9_SetFogDensity_PF( float density ) ;													// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D9_ApplyLigFogToHardware_PF( void ) ;													// {f[^ɐݒ肳ĂtHOn[hEFAɔf
extern	int		Graphics_Hardware_D3D9_SetUseOldDrawModiGraphCodeFlag_PF( int Flag ) ;										// ȑO DrawModiGraph ֐̃R[hgp邩ǂ̃tOZbg
extern	int		Graphics_Hardware_D3D9_RefreshAlphaChDrawMode_PF( void ) ;													// `ɐlނǂ̃tOXV








// ˑݒ֌W
extern	int		Graphics_Hardware_D3D9_SetUseHardwareVertexProcessing_PF( int Flag ) ;						// n[hEGA̒_Z@\gp邩ǂݒ肷
extern	int		Graphics_Hardware_D3D9_SetUsePixelLighting_PF( int Flag ) ;									// sNZPʂŃCeBOsǂݒ肷Av ShaderModel 3.0( TRUE:sNZPʂ̃CeBOs  FALSE:_Pʂ̃CeBOs( ftHg ) )
extern	int		Graphics_Hardware_D3D9_SetGraphicsDeviceRestoreCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData ) ;			// OtBbNXfoCXXg畜AۂɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D9_SetGraphicsDeviceLostCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData ) ;			// OtBbNXfoCXXg畜AOɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D9_SetUseNormalDrawShader_PF( int Flag ) ;								// ʏ`ɃvO}uVF[_[gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_Hardware_D3D9_SetMultiThreadFlag_PF( int Flag ) ;									// DirectDraw  Direct3D ̋x}`XbhΉɂ邩ǂZbg
extern	int		Graphics_Hardware_D3D9_GetVideoMemorySize_PF( int *AllSize, int *FreeSize ) ;				// rfI̗eʂ𓾂
extern	const D_IDirect3DDevice9 * Graphics_Hardware_D3D9_GetUseDirect3DDevice9_PF( void ) ;				// gp̂cRccXIuWFNg𓾂
extern	const D_IDirect3DSurface9* Graphics_Hardware_D3D9_GetUseDirect3D9BackBufferSurface_PF( void ) ;		// gp̃obNobt@Direct3DSurface9IuWFNg擾
extern	int		Graphics_Hardware_D3D9_RefreshDxLibDirect3DSetting_PF( void ) ;								// cwCûcRcݒȂ
extern	int		Graphics_D3D9_SetDDrawUseGuid_PF( const GUID FAR *Guid ) ;									// ccgpfthcݒ肷
extern	const GUID *Graphics_D3D9_GetDirectDrawDeviceGUID_PF( int Number ) ;								// L DirectDraw foCX GUID 擾
extern	int		Graphics_D3D9_GetDirectDrawDeviceDescription_PF( int Number, char *StringBuffer ) ;			// L DirectDraw foCX̖O𓾂
extern	int		Graphics_D3D9_GetDirectDrawDeviceNum_PF( void ) ;											// L DirectDraw foCX̐擾
//extern	int		Graphics_D3D9_SetUseDirectDrawDeviceIndex_PF( int Index ) ;									// gp DirectDraw foCX̃CfbNXݒ肷
extern	int		Graphics_D3D9_SetUseDirect3D9Ex_PF( int Flag ) ;											// Vistaȍ~̊ Direct3D9Ex gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_D3D9_SetDialogBoxMode_PF( int Flag ) ;												// _CAO{bNX[hύX








// ˑʊ֌W
extern	int		Graphics_Hardware_D3D9_SetupUseZBuffer_PF( void ) ;															// ݒɊÂĎgpyobt@Zbg
extern	int		Graphics_Hardware_D3D9_ClearDrawScreenZBuffer_PF( const RECT *ClearRect ) ;									// ʂ̂yobt@̏Ԃ
extern	int		Graphics_Hardware_D3D9_ClearDrawScreen_PF( const RECT *ClearRect ) ;										// ʂ̏Ԃ
extern	int		Graphics_Hardware_D3D9_SetDrawScreen_PF( int DrawScreen, int OldScreenSurface, IMAGEDATA *NewTargetImage, IMAGEDATA *OldTargetImage, SHADOWMAPDATA *NewTargetShadowMap, SHADOWMAPDATA *OldTargetShadowMap ) ;						// `ʂ̃Zbg
extern	int		Graphics_Hardware_D3D9_SetDrawScreen_Post_PF( int DrawScreen ) ;											// SetDrawScreen ̍ŌŌĂ΂֐
extern	int		Graphics_Hardware_D3D9_SetDrawArea_PF( int x1, int y1, int x2, int y2 ) ;									// `\̈̃Zbg
extern	int		Graphics_Hardware_D3D9_LockDrawScreenBuffer_PF( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen, IMAGEDATA *TargetImage, int TargetScreenSurface, int ReadOnly, int TargetScreenTextureNo ) ;	// `obt@bN
extern	int		Graphics_Hardware_D3D9_UnlockDrawScreenBuffer_PF( void ) ;													// `obt@AbN
extern	int		Graphics_Hardware_D3D9_ScreenCopy_PF( void ) ;																// ʂ̓e\ʂɕ`悷
extern	int		Graphics_Hardware_D3D9_SaveDrawScreen_Begin_PF( int x1, int y1, int x2, int y2, BASEIMAGE *BaseImage ) ;	// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_D3D9_SaveDrawScreen_Post_PF( void ) ;														// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_D3D9_WaitVSync_PF( int SyncNum ) ;														// M҂
extern	int		Graphics_Hardware_D3D9_ScreenFlipBase_PF( void ) ;															// ʂƕ\ʂ
extern	int		Graphics_Hardware_D3D9_BltRectBackScreenToWindow_PF( HWND Window, RECT BackScreenRect, RECT WindowClientRect ) ;		// ʂ̎ẅ̗EChẼNCAg̈̎ẅ̗ɓ]
extern	int		Graphics_Hardware_D3D9_SetScreenFlipTargetWindow_PF( HWND TargetWindow ) ;									// ScreenFlip ŉ摜]̃EChEݒ肷( NULL w肷Ɛݒ )
extern	int		Graphics_Hardware_D3D9_SetZBufferMode_PF( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth ) ;		// Cʂ̂yobt@̐ݒύX
extern	int		Graphics_Hardware_D3D9_SetDrawZBuffer_PF( int DrawScreen, IMAGEDATA *Image ) ;								// `yobt@̃Zbg








// ˑ擾֌W
extern	const COLORDATA *	Graphics_Hardware_D3D9_GetMainColorData_PF( void ) ;				// GetColor  GetColor2 ŎgpJ[f[^擾
extern	const COLORDATA *	Graphics_Hardware_D3D9_GetDispColorData_PF( void ) ;				// fBXv[̃J[f[^|C^𓾂
extern	DWORD				Graphics_Hardware_D3D9_GetPixel_PF( int x, int y ) ;				// wW̐F擾








// ˑ摜֌W
extern	int		Graphics_Hardware_D3D9_UpdateGraphMovie_TheoraYUV_PF( MOVIEGRAPH *Movie, IMAGEDATA *Image ) ;			// YUVT[tFXg Theora ̓eOtBbNXnh̃eNX`ɓ]
extern	int		Graphics_Hardware_D3D9_GraphLock_PF( IMAGEDATA *Image, COLORDATA **ColorDataP, int WriteOnly ) ;		// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D9_GraphUnlock_PF( IMAGEDATA *Image ) ;												// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D9_CopyGraphZBufferImage_PF( IMAGEDATA *DestImage, IMAGEDATA *SrcImage ) ;			// OtBbN̂yobt@̏Ԃʂ̃OtBbN̂yobt@ɃRs[( DestGrHandle  SrcGrHandle yobt@Ă`\摜ŁAA`GCAX摜ł͂ȂƂ )
extern	int		Graphics_Hardware_D3D9_InitGraph_PF( void ) ;															// 摜f[^̏
extern	int		Graphics_Hardware_D3D9_FillGraph_PF( IMAGEDATA *Image, int Red, int Green, int Blue, int Alpha, int ASyncThread ) ;			// OtBbN̐FœhԂ
extern	int		Graphics_Hardware_D3D9_GetDrawScreenGraphBase_PF( IMAGEDATA *Image, IMAGEDATA *TargetImage, int TargetScreen, int TargetScreenSurface, int TargetScreenWidth, int TargetScreenHeight, int x1, int y1, int x2, int y2, int destX, int destY ) ;		// `\摜obNobt@ẅ̃OtBbN擾

// Direct3D9 ̃OtBbNnhɉ摜f[^]邽߂̊֐
extern	int		Graphics_Hardware_D3D9_BltBmpOrBaseImageToGraph3_PF(
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		RedIsAlphaFlag,
	      int		UseTransColorConvAlpha,
	      int		TargetOrig,
	      int		ASyncThread
) ;

extern	int		Graphics_Hardware_D3D9_CreateOrigTexture_PF(  IMAGEDATA_ORIG *Orig, int ASyncThread = FALSE ) ;		// IWi摜񒆂̃eNX`쐬( 0:  -1:s )
extern	int		Graphics_Hardware_D3D9_ReleaseOrigTexture_PF( IMAGEDATA_ORIG *Orig ) ;								// IWi摜񒆂̃eNX`
extern	int		Graphics_Hardware_D3D9_GetMultiSampleQuality_PF( int Samples ) ;									// w̃}`TvŎgpłőNIeBl擾








// ˑ_obt@ECfbNXobt@֌W
extern	int		Graphics_Hardware_D3D9_VertexBuffer_Create_PF(    VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;															// _obt@nh̒_obt@쐬
extern	int		Graphics_Hardware_D3D9_VertexBuffer_Terminate_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;															// _obt@nȟn
extern	int		Graphics_Hardware_D3D9_VertexBuffer_SetData_PF(   VERTEXBUFFERHANDLEDATA *VertexBuffer, int SetIndex, const void *VertexData, int VertexNum ) ;		// _obt@ɒ_f[^]
extern	int		Graphics_Hardware_D3D9_IndexBuffer_Create_PF(     INDEXBUFFERHANDLEDATA *IndexBuffer ) ;															// CfbNXobt@nh̃ZbgAbvs
extern	int		Graphics_Hardware_D3D9_IndexBuffer_Terminate_PF(  INDEXBUFFERHANDLEDATA *IndexBuffer ) ;															// CfbNXobt@nȟn
extern	int		Graphics_Hardware_D3D9_IndexBuffer_SetData_PF(    INDEXBUFFERHANDLEDATA *IndexBuffer, int SetIndex, const void *IndexData, int IndexNum ) ;			// CfbNXobt@ɃCfbNXf[^]









// ˑCg֌W
extern	int		Graphics_Hardware_D3D9_Light_SetUse_PF( int Flag ) ;															// CeBOsǂݒ肷
extern	int		Graphics_Hardware_D3D9_Light_GlobalAmbient_PF( COLOR_F *Color ) ;												// O[oArGgCgJ[ݒ肷
extern	int		Graphics_Hardware_D3D9_Light_SetState_PF( int LightNumber, LIGHTPARAM *LightParam ) ;							// Cgp[^Zbg
extern	int		Graphics_Hardware_D3D9_Light_SetEnable_PF( int LightNumber, int EnableState ) ;									// Cg̗LAύX








// ˑVhE}bv֌W
extern	int		Graphics_Hardware_D3D9_ShadowMap_CreateTexture_PF( SHADOWMAPDATA *ShadowMap, int ASyncThread = FALSE ) ;		// VhE}bvf[^ɕKvȃeNX`쐬
extern	int		Graphics_Hardware_D3D9_ShadowMap_ReleaseTexture_PF( SHADOWMAPDATA *ShadowMap ) ;								// VhE}bvf[^ɕKvȃeNX`
extern	void	Graphics_Hardware_D3D9_ShadowMap_RefreshVSParam_PF( void ) ;													// _VF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_D3D9_ShadowMap_RefreshPSParam_PF( void ) ;													// sNZVF[_[ɐݒ肷VhE}bv̏XV
extern	int		Graphics_Hardware_D3D9_ShadowMap_DrawSetup_PF( SHADOWMAPDATA *ShadowMap ) ;										// VhE}bvւ̕`̏s
extern	int		Graphics_Hardware_D3D9_ShadowMap_DrawEnd_PF( SHADOWMAPDATA *ShadowMap ) ;										// VhE}bvւ̕`I
extern	int		Graphics_Hardware_D3D9_ShadowMap_SetUse_PF( int SlotIndex, SHADOWMAPDATA *ShadowMap ) ;							// `ŎgpVhE}bvw肷AXbg͂OPw\








// ˑVF[_[֌W
extern	int		Graphics_Hardware_D3D9_Shader_Create_PF( int ShaderHandle, int IsVertexShader, void *Image, int ImageSize, int ImageAfterFree, int ASyncThread ) ;		// VF[_[nh
extern	int		Graphics_Hardware_D3D9_Shader_TerminateHandle_PF( SHADERHANDLEDATA *Shader ) ;																			// VF[_[nȟn
extern	int		Graphics_Hardware_D3D9_Shader_GetValidShaderVersion_PF( void ) ;																							// gpłVF[_[̃o[W擾( 0=gȂ  200=VF[_[fQDOgp\  300=VF[_[fRDOgp\ )
extern	int		Graphics_Hardware_D3D9_Shader_GetConstIndex_PF( const wchar_t *ConstantName, SHADERHANDLEDATA *Shader ) ;													// w̖O萔gpVF[_[萔̔ԍ擾
extern	int		Graphics_Hardware_D3D9_Shader_GetConstCount_PF( const wchar_t *ConstantName, SHADERHANDLEDATA *Shader ) ;													// w̖O萔gpVF[_[萔̐擾
extern	const FLOAT4 *Graphics_Hardware_D3D9_Shader_GetConstDefaultParamF_PF( const wchar_t *ConstantName, SHADERHANDLEDATA *Shader ) ;									// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	int		Graphics_Hardware_D3D9_Shader_SetConst_PF(   int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea ) ;	// VF[_[萔ݒ肷
extern	int		Graphics_Hardware_D3D9_Shader_ResetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum ) ;											// ẅ̃VF[_[萔Zbg
extern	int		Graphics_Hardware_D3D9_Shader_ModelCode_Init_PF( void ) ;																								// Rcfp̃VF[_[R[h̏s








// ˑVF[_[p萔obt@֌W
extern	int		Graphics_Hardware_D3D9_ShaderConstantBuffer_Create_PF( int ShaderConstantBufferHandle, int BufferSize, int ASyncThread ) ;												// VF[_[p萔obt@nh
extern	int		Graphics_Hardware_D3D9_ShaderConstantBuffer_TerminateHandle_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ) ;													// VF[_[p萔obt@nȟn
extern	void *	Graphics_Hardware_D3D9_ShaderConstantBuffer_GetBuffer_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ) ;														// VF[_[p萔obt@nh̒萔obt@̃AhX擾
extern	int		Graphics_Hardware_D3D9_ShaderConstantBuffer_Update_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer ) ;															// VF[_[p萔obt@nh̒萔obt@ւ̕ύXKp
extern	int		Graphics_Hardware_D3D9_ShaderConstantBuffer_Set_PF( SHADERCONSTANTBUFFERHANDLEDATA *ShaderConstantBuffer, int TargetShader /* DX_SHADERTYPE_VERTEX Ȃ */, int Slot ) ;	// VF[_[p萔obt@nh̒萔obt@w̃VF[_[̎w̃XbgɃZbg








// ˑ`֌W
extern	int		Graphics_Hardware_D3D9_Paint_PF( int x, int y, unsigned int FillColor, ULONGLONG BoundaryColor ) ;			// w_狫EFƂ܂œhԂ






#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_DIRECT3D9

#endif // __DXGRAPHICSD3D9_H__
