// -------------------------------------------------------------------------------
// 
// 		cwCu		}XNvO( Direct3D11 )wb_t@C
// 
// 				Ver 3.15a
// 
// -------------------------------------------------------------------------------

#ifndef __DXMASKD3D11_H__
#define __DXMASKD3D11_H__

#include "../DxCompileConfig.h"

#ifndef DX_NON_DIRECT3D11

// CN[h ------------------------------------------------------------------
#include "../DxLib.h"
#include "../DxGraphics.h"
#include "../DxArchive_.h"
#include "DxGraphicsAPIWin.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

#define MASKD3D11					MaskManageData_D3D11


// \̒` --------------------------------------------------------------------


// Direct3D11 gOtBbNX̍\
struct MASKMANAGEDATA_DIRECT3D11
{
	int								MaskTextureSizeX ;				// }XNeNX`̃TCY
	int								MaskTextureSizeY ;

	D_ID3D11Texture2D *				MaskScreenTexture ;				// }XNpʃeNX`
	D_ID3D11ShaderResourceView *	MaskScreenTextureSRV ;			// }XNpʃeNX`VF[_[\[Xr[
	D_ID3D11RenderTargetView *		MaskScreenTextureRTV ;			// }XNpʃeNX`_O^[Qbgr[

	D_ID3D11Texture2D *				MaskScreenTextureOld ;			// Â}XNpʃeNX`
	D_ID3D11ShaderResourceView *	MaskScreenTextureOldSRV ;		// Â}XNpʃeNX`VF[_[\[Xr[
	D_ID3D11RenderTargetView *		MaskScreenTextureOldRTV ;		// Â}XNpʃeNX`_O^[Qbgr[

	D_ID3D11Texture2D *				MaskImageTexture ;				// }XNC[WeNX`
	D_ID3D11ShaderResourceView *	MaskImageTextureSRV ;			// }XNC[WeNX`VF[_[\[Xr[

	D_ID3D11Texture2D *				DestTargetTexture2D ;			// `Ώۂ̃eNX`
	D_ID3D11ShaderResourceView *	DestTargetSRV ;					// `Ώۂ̃VF[_[\[Xr[
	D_ID3D11RenderTargetView *		DestTargetRTV ;					// `Ώۂ̃_O^[Qbgr[

	D_ID3D11Texture2D *				DestTargetDepthTexture2D ;		// `Ώۂ̐[xeNX`
	D_ID3D11DepthStencilView *		DestTargetDepthDSV ;			// `Ώۂ̐[xXeVr[
} ;


// ϐ錾 --------------------------------------------------------------

extern MASKMANAGEDATA_DIRECT3D11 MaskManageData_D3D11 ;

// ֐vg^Cv錾-----------------------------------------------------------


// ˑ֐
extern	int			Mask_D3D11_CreateScreenFunction_Timing0_PF( void ) ;														// }XNXN[쐬֐
extern	int			Mask_D3D11_CreateScreenFunction_Timing1_PF( int Width, int Height ) ;									// }XNXN[쐬֐
extern	int			Mask_D3D11_CreateScreenFunction_Timing2_PF( int MaskBufferSizeXOld, int MaskBufferSizeYOld ) ;			// }XNXN[쐬֐
extern	int			Mask_D3D11_ReleaseSurface_PF( void ) ;																	// }XNXN[ꎞ폜
extern	int			Mask_D3D11_SetUseMaskScreenFlag_PF( void ) ;																// }XNgp[hύX
extern	int			Mask_D3D11_DrawBeginFunction_PF( RECT *Rect ) ;															// }XNgp`̑OɌĂԊ֐( łɃTuobt@gp`GA@\gpĂꍇ̏Ă܂Ă )
extern	int			Mask_D3D11_DrawAfterFunction_PF( RECT *Rect ) ;															// }XNgp`̌ɌĂԊ֐( łɃTuobt@gp`GA@\gpĂꍇ̏Ă܂Ă )
extern	int			Mask_D3D11_FillMaskScreen_PF( int Flag ) ;																// }XNXN[w̐FœhԂ
extern	int			Mask_D3D11_UpdateMaskImageTexture_PF( RECT *Rect ) ;															// ẅ̃}XNC[WeNX`XV


#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_DIRECT3D11

#endif // __DXMASKD3D11_H__

